const FIRST_MESSAGES = ["リッツは目を覚ますと薄暗いダンジョンの中にいた...", "リッツ「えっ？！ここは一体どこなの・・・？」", "＊「と、とにかくここから脱出しなくちゃ」"];

const ITEM_COUNT = 21;
const ITEM_DISPLAY_COUNT = 5;

var ITEM_TYPES = [
	[0, "聖水", "不思議な魔力が込められた水"],
	[1, "生肉", "生肉。焼けばおいしく食べられるかも...？"],
	[2, "焼いた肉", "こんがりおいしく焼けました"],
	[3, "さびたカギ", "さびていて使えそうにない。磨けば光るかも？"],
	[4, "赤いカギ", "赤く輝くカギ"],
	[5, "クリスタルランプ", "奥からぼんやりと光っている。燭台につけて辺りを照らそう"],
	[6, "クリスタルランプ", "奥からぼんやりと光っている。燭台につけて辺りを照らそう"],
	[7, "釣り竿", "竹竿に紐と針がつけられている"],
	[8, "青いカギ", "青く輝くカギ"],
	[9, "ファイアーロッド", "炎を出せる杖"],
	[10, "フグ", "水を無限に吐き出せそう"],
	[11, "ハンマー", "なにかを叩くための道具"],
	[12, "桐箱", "何かが入っていそうだが...開ける隙間がない"],
	[13, "眠り姫のオルゴール", "眠りの歌を奏でるオルゴール"],
	[14, "燃えた桐箱", "あと一息で壊れそう"],
	[15, "赤メダル", "赤色のメダル"],
	[16, "青メダル", "青色のメダル"],
	[17, "緑メダル", "緑色のメダル"],
	[18, "羊皮紙", "なにも書いていない...？"],
	[19, "羊皮紙", "X ◯ X X X ◯ と書いてあるようだ"],
	[20, "緑のカギ", "緑色のカギ"]
];

const E_PICK_KEY0 = 0;// : 錆びたカギをひろう(E_PICK_KEY0)
const E_PICK_POTION = 1;//  : 聖水をひろう(E_PICK_POTION)
const E_PICK_MEAT1 = 2;//  : 生肉をひろう(E_PICK_MEAT1)
const E_GET_KEY1 = 3;//  : さびたカギにせいすいをかけた　赤い鍵GET(E_GET_KEY1)
const E_USE_KEY1 = 4;//  : 赤いカギ使った (E_USE_KEY1)
const E_PICK_LUMP = 5;// ：ランプを拾った
const E_PICK_KEY2 = 6;// ：青いカギを拾った
const E_USE_KEY2 = 7;// ：青いカギを使った
const E_PICK_CRYSTAL = 8;// ：クリスタル拾った
const E_LUMP_STATUS = 9;//　ランプステータス
const E_PICK_SAO = 10;//　竿拾った
const E_PICK_FUGU = 11;//フグ釣った
const E_PICK_CRYSTAL2 = 12;//クリスタル釣った
const E_PICK_ROD = 13; //ファイアーロッド拾う
const E_FIRE_MEAT = 14; //肉に火を通す
const E_FIRE_POD = 15; //つぼに火を通す
const E_USE_FUGU = 16; //たからばこに水をかけた
const E_OPEN_DOOR3 = 17; //room3を開けた
const E_GIVE_MEAT = 18; //肉をあげた
const E_SLEEP_GOBLIN = 19;//ゴブリンを眠らせた
const E_WIN_FAIRY = 20;//ジャンケン妖精に勝利　ケース
const E_PICK_HAMMER = 21; //ハンマーを拾う
const E_BREAK_POD1 = 22; //つぼ破壊1 : room1-1
const E_BREAK_POD2 = 23; //つぼ破壊2 : room1-2
const E_BREAK_POD3 = 24; //つぼ破壊3 : room1-3
const E_BREAK_POD4 = 25; //つぼ破壊4 : room4-1
const E_BREAK_POD5 = 33; //つぼ破壊5 : room5-1
const E_SLEEP_FAIRY1 = 26;//お助け妖精を眠らせた1
const E_SLEEP_FAIRY2 = 27;//お助け妖精を眠らせた2
const E_SLEEP_FAIRY3 = 28;//お助け妖精を眠らせた3
const E_USE_KEY3 = 29;// ：緑カギを使った
const E_PICK_KEY3 = 30;// かぎを拾った緑
const E_FIRE_BOX = 31;//桐箱に火
const E_BREAK_BOX = 32;//桐箱破壊
const E_PICK_PAPER = 34;//紙ひろう
const E_FIRE_PAPER = 35;//あぶり出し
const E_PICK_MEDAL1 = 36;//メダル赤
const E_PICK_MEDAL2 = 37;//メダル青
const E_PICK_MEDAL3 = 38;//メダル緑
const E_SET_LUMPS = 39;//ランプセット
const E_MEDAL_STATUS = 40;//メダル設定
const E_OPEN_DOOR5 = 41;//最後のドア開け
const E_SET_MEDAL1 = 42;//赤メダルセット
const E_SET_MEDAL2 = 43;//青メダルセット
const E_SET_MEDAL3 = 44;//緑メダルセット
const E_GAME_FIRST = 45;//ゲームスタート文言


const DEFAULT_POSITION = 0;
const DEFAULT_EVENTS = [0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0];
const DEFAULT_ITEMS  = [0, 0, 0, 0, 0,   0, 0, 0, 0, 0,   0, 0, 0, 0, 0,   0, 0, 0, 0, 0,  0];
const DEFAULT_GALLERIES = [1, 1, 0, 0, 0, 0, 0, 0];
var lump_statuses = [0, 0, 0, 0, 0, 0];
var medal_statuses = [0, 0, 0];

const URL_CLEAR = "https://www.printdora.net/home/sendClear.php";
const URL_TELL_NAME = "https://www.printdora.net/home/tellName.php";

//-----------------------------------
//ゲームページ　オプション一覧
//-----------------------------------

//オプション全非表示
function unVisibleOption(obj) {
	//キャラ
	obj.fairy_mc.visible = false;//ジャンケン妖精
	obj.rt_mc.visible = false;//リッツ
	obj.rt_mc2.visible = false;//リッツ2
	//displayTutorial(obj);

	//room1
	obj.o1.visible = false;
	obj.btn_o1.visible = false;//ドア
	obj.o2.visible = false;
	obj.o3.visible = false;
	obj.btn_o3.visible = false;
	obj.o4.visible = false;
	obj.btn_o4.visible = false;
	obj.o5.visible = false;
	obj.btn_o5.visible = false;
	obj.o6.visible = false;
	obj.btn_o6.visible = false;
	obj.o32.visible = false;//お助け妖精
	obj.btn_o32.visible = false;
	obj.o41.visible = false;//お助け妖精　ねている
	obj.btn_o41.visible = false;
	obj.o50.visible = false;

	//room2
	obj.o7.visible = false;//影0
	obj.o8.visible = false;//影1
	obj.o9.visible = false;//影2
	obj.o10.visible = false;//影3
	obj.o11.visible = false;//影4
	obj.o12.visible = false;//燭台0　左
	obj.btn_o12.visible = false;//燭台　左
	obj.o13.visible = false;
	obj.btn_o13.visible = false;//燭台　右
	obj.o14.visible = false;//ランプ　左
	obj.o15.visible = false;//ランプ　右
	obj.o16.visible = false;
	obj.btn_o16.visible = false;//ロープ　左
	obj.o17.visible = false;
	obj.btn_o17.visible = false;//宝箱
	obj.o18.visible = false;
	obj.btn_o18.visible = false;//ロープ　右
	obj.o19.visible = false;
	obj.o20.visible = false;
	obj.o21.visible = false;
	obj.btn_o21.visible = false;//おちてるクリスタル
	obj.o22.visible = false;//開いてる宝箱
	obj.o23.visible = false;//青い鍵
	obj.btn_o23.visible = false;//青い鍵
	obj.o48.visible = false;//宝箱
	obj.o49.visible = false;//アキ
	obj.btn_o48.visible = false;//

	//room3
	obj.o24.visible = false;//ゴブリン
	obj.o25.visible = false;//赤いたから
	obj.o26.visible = false;//たから
	obj.o27.visible = false;//から
	obj.o28.visible = false;////どいたゴブリン
	obj.o29.visible = false;//池
	obj.o30.visible = false;//ドア
	obj.o31.visible = false;//ドアあき
	obj.o42.visible = false;//ねているゴブリン
	obj.btn_o24.visible = false;
	obj.btn_o25.visible = false;
	obj.btn_o28.visible = false;
	obj.btn_o29.visible = false;

	//room4
	obj.o33.visible = false;//緑カギ
	obj.btn_o33.visible = false;
	obj.o34.visible = false;//ひびつぼ
	obj.btn_o34.visible = false;
	obj.o35.visible = false;//ドア
	obj.o36.visible = false;//あきドア
	obj.o37.visible = false;//妖精2 ドア
	obj.btn_o37.visible = false;
	obj.o38.visible = false;//妖精3 ジャンケン
	obj.btn_o38.visible = false;
	obj.o39.visible = false;//妖精2寝る
	obj.btn_o39.visible = false;
	obj.o40.visible = false;//妖精3寝る
	obj.btn_o40.visible = false;

	//room5
	obj.o43.visible = false;//緑カギ
	obj.btn_o43.visible = false;
	obj.o44.visible = false;//かみ
	obj.btn_o44.visible = false;
	obj.o45.visible = false;//ドア手前
	obj.o46.visible = false;//外
	obj.o47.visible = false;//天井
	obj.o51.visible = false;//メダル1
	obj.o52.visible = false;//メダル2
	obj.o53.visible = false;//メダル3

	//clear
	obj.clear_date_txt2.visible = false;
	obj.clear_mc.visible = false;
	obj.ranking_mc.visible = false;
	obj.clear_back_mc.visible = false;
	obj.btn_tweet.visible = false;
	obj.tweet_mc.visible = false;
	obj.ready_clear_str_mc.visible = false;
	obj.ready_clear_back_mc.visible = false;


}

//-----------------------------------
//ゲームページ　リスナー
//-----------------------------------
function addGameListener(obj) {
	obj.btn_save.addEventListener('click', obj, false);
	obj.btn_save.addEventListener('touchstart', obj, false);
	obj.btn_sound.addEventListener('click', obj, false);
	obj.btn_sound.addEventListener('touchstart', obj, false);
	obj.btn_top.addEventListener('click', obj, false);
	obj.btn_top.addEventListener('touchstart', obj, false);

	//アイテム　＆　アイテムカーソル　＆　場所移動
	obj.btn_icl.addEventListener('click', obj, false);
	obj.btn_icl.addEventListener('touchstart', obj, false);
	obj.btn_icr.addEventListener('click', obj, false);
	obj.btn_icr.addEventListener('touchstart', obj, false);

	obj.btn_i1.addEventListener('click', obj, false);
	obj.btn_i1.addEventListener('touchstart', obj, false);
	obj.btn_i2.addEventListener('click', obj, false);
	obj.btn_i2.addEventListener('touchstart', obj, false);
	obj.btn_i3.addEventListener('click', obj, false);
	obj.btn_i3.addEventListener('touchstart', obj, false);
	obj.btn_i4.addEventListener('click', obj, false);
	obj.btn_i4.addEventListener('touchstart', obj, false);
	obj.btn_i5.addEventListener('click', obj, false);
	obj.btn_i5.addEventListener('touchstart', obj, false);

	obj.btn_itemdetail_close.addEventListener('click', obj, false);
	obj.btn_itemdetail_close.addEventListener('touchstart', obj, false);
	obj.btn_item_detail.addEventListener('click', obj, false);
	obj.btn_item_detail.addEventListener('touchstart', obj, false);

	obj.btn_move_r.addEventListener('click', obj, false);
	obj.btn_move_r.addEventListener('touchstart', obj, false);
	obj.btn_move_l.addEventListener('click', obj, false);
	obj.btn_move_l.addEventListener('touchstart', obj, false);
	obj.btn_move_t.addEventListener('click', obj, false);
	obj.btn_move_t.addEventListener('touchstart', obj, false);
	obj.btn_move_d.addEventListener('click', obj, false);
	obj.btn_move_d.addEventListener('touchstart', obj, false);

	obj.btn_sel1.addEventListener('click', obj, false);
	obj.btn_sel1.addEventListener('touchstart', obj, false);
	obj.btn_sel2.addEventListener('click', obj, false);
	obj.btn_sel2.addEventListener('touchstart', obj, false);
	obj.btn_sel3.addEventListener('click', obj, false);
	obj.btn_sel3.addEventListener('touchstart', obj, false);
	obj.btn_sel4.addEventListener('click', obj, false);
	obj.btn_sel4.addEventListener('touchstart', obj, false);

	addOptionListener(obj);

	//obj.game_touch_mc.addEventListener('click', obj, false);
	//obj.game_touch_mc.addEventListener('touchstart', obj, false);

	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "btn_icl") {
	      		if(obj.itemPosition > 0) {
	        		obj.itemPosition--;
	        		setGameItems(obj, obj.itemPosition);
	        	}
	        } else if(event.target.parent.name == "btn_icr") {
	        	if(obj.itemPosition + 5 < obj.itemKindCount) {
	        		obj.itemPosition++;
	        		setGameItems(obj, obj.itemPosition);
	        	}
	        } else if(ITEM_REGEXP.test(event.target.parent.name)) {
	        	//アイテム
	        	if(obj.optionEvent == 1) obj.optionEvent = 0;
	        	onItem(obj, event.target.parent.name.substr(5));
	        } else if(SELECT_REGEXP.test(event.target.parent.name)) {
	        	//選択肢
	        	onSelect(obj, event.target.parent.name.substr(7));
	        } else if(event.target.parent.name == "btn_itemdetail_close") {
	      		//選択解除
	        	unDisplayItemDetail(obj);
	        } else if(event.target.parent.name == "btn_item_detail") {
	      		onItemDetail(obj);
	        } else if(event.target.parent.name == "btn_message") {
	      		//メッセージタッチ
	        	onMessage(obj);
	        } else if(event.target.parent.name == "btn_move_r") {
	      		onMove(obj, 1);
	        } else if(event.target.parent.name == "btn_move_l") {
	      		onMove(obj, 3);
	        } else if(event.target.parent.name == "btn_move_t") {
	      		onMove(obj, 0);
	        } else if(event.target.parent.name == "btn_move_d") {
	      		onMove(obj, 2);
	        } else if(OPTION_REGEXP.test(event.target.parent.name)) {
	        	if(obj.optionEvent == 1) obj.optionEvent = 0;
	        	onOption(obj, event.target.parent.name.substr(5));
	        } else if(event.target.parent.name == "btn_save") {
	      		onSave(obj);
	        } else if(event.target.parent.name == "btn_sound") {
	      		onSound(obj);
	        } else if(event.target.parent.name == "btn_top") {
	      		onTop(obj);
	        } else if(event.target.parent.name == "btn_tweet") {
	      		onTweet(obj);
	        } else {
	        }
	        break;
	    }
	};
}

//ゲームページ　リスナー削除
function removeGameListener(obj) {
	obj.btn_save.removeEventListener('click', obj, false);
	obj.btn_save.removeEventListener('touchstart', obj, false);
	obj.btn_sound.removeEventListener('click', obj, false);
	obj.btn_sound.removeEventListener('touchstart', obj, false);
	obj.btn_top.removeEventListener('click', obj, false);
	obj.btn_top.removeEventListener('touchstart', obj, false);

	obj.btn_icl.removeEventListener('click', obj, false);
	obj.btn_icl.removeEventListener('touchstart', obj, false);
	obj.btn_icr.removeEventListener('click', obj, false);
	obj.btn_icr.removeEventListener('touchstart', obj, false);
	obj.btn_i1.removeEventListener('click', obj, false);
	obj.btn_i1.removeEventListener('touchstart', obj, false);
	obj.btn_i2.removeEventListener('click', obj, false);
	obj.btn_i2.removeEventListener('touchstart', obj, false);
	obj.btn_i3.removeEventListener('click', obj, false);
	obj.btn_i3.removeEventListener('touchstart', obj, false);
	obj.btn_i4.removeEventListener('click', obj, false);
	obj.btn_i4.removeEventListener('touchstart', obj, false);
	obj.btn_i5.removeEventListener('click', obj, false);
	obj.btn_i5.removeEventListener('touchstart', obj, false);
	obj.btn_itemdetail_close.removeEventListener('click', obj, false);
	obj.btn_itemdetail_close.removeEventListener('touchstart', obj, false);
	obj.btn_message.removeEventListener('click', obj, false);
	obj.btn_message.removeEventListener('touchstart', obj, false);

	obj.btn_move_r.removeEventListener('click', obj, false);
	obj.btn_move_r.removeEventListener('touchstart', obj, false);
	obj.btn_move_l.removeEventListener('click', obj, false);
	obj.btn_move_l.removeEventListener('touchstart', obj, false);
	obj.btn_move_t.removeEventListener('click', obj, false);
	obj.btn_move_t.removeEventListener('touchstart', obj, false);
	obj.btn_move_d.removeEventListener('click', obj, false);
	obj.btn_move_d.removeEventListener('touchstart', obj, false);

	obj.btn_sel1.removeEventListener('click', obj, false);
	obj.btn_sel1.removeEventListener('touchstart', obj, false);
	obj.btn_sel2.removeEventListener('click', obj, false);
	obj.btn_sel2.removeEventListener('touchstart', obj, false);
	obj.btn_sel3.removeEventListener('click', obj, false);
	obj.btn_sel3.removeEventListener('touchstart', obj, false);
	obj.btn_sel4.removeEventListener('click', obj, false);
	obj.btn_sel4.removeEventListener('touchstart', obj, false);
}

//オプションリスナー
function addOptionListener(obj) {
	//room1
	obj.btn_o1.addEventListener('click', obj, false);
	obj.btn_o1.addEventListener('touchstart', obj, false);
	obj.btn_o3.addEventListener('click', obj, false);
	obj.btn_o3.addEventListener('touchstart', obj, false);
	obj.btn_o4.addEventListener('click', obj, false);
	obj.btn_o4.addEventListener('touchstart', obj, false);
	obj.btn_o5.addEventListener('click', obj, false);
	obj.btn_o5.addEventListener('touchstart', obj, false);
	obj.btn_o6.addEventListener('click', obj, false);
	obj.btn_o6.addEventListener('touchstart', obj, false);
	obj.btn_o32.addEventListener('click', obj, false);
	obj.btn_o32.addEventListener('touchstart', obj, false);
	obj.btn_o41.addEventListener('click', obj, false);
	obj.btn_o41.addEventListener('touchstart', obj, false);	

	//room2
	obj.btn_o12.addEventListener('click', obj, false);
	obj.btn_o12.addEventListener('touchstart', obj, false);
	obj.btn_o13.addEventListener('click', obj, false);
	obj.btn_o13.addEventListener('touchstart', obj, false);
	obj.btn_o16.addEventListener('click', obj, false);
	obj.btn_o16.addEventListener('touchstart', obj, false);
	obj.btn_o17.addEventListener('click', obj, false);
	obj.btn_o17.addEventListener('touchstart', obj, false);
	obj.btn_o18.addEventListener('click', obj, false);
	obj.btn_o18.addEventListener('touchstart', obj, false);
	obj.btn_o21.addEventListener('click', obj, false);
	obj.btn_o21.addEventListener('touchstart', obj, false);
	obj.btn_o23.addEventListener('click', obj, false);
	obj.btn_o23.addEventListener('touchstart', obj, false);
	obj.btn_o48.addEventListener('click', obj, false);
	obj.btn_o48.addEventListener('touchstart', obj, false);	

	//room3
	obj.btn_o24.addEventListener('click', obj, false);
	obj.btn_o24.addEventListener('touchstart', obj, false);
	obj.btn_o25.addEventListener('click', obj, false);
	obj.btn_o25.addEventListener('touchstart', obj, false);
	obj.btn_o28.addEventListener('click', obj, false);
	obj.btn_o28.addEventListener('touchstart', obj, false);
	obj.btn_o29.addEventListener('click', obj, false);
	obj.btn_o29.addEventListener('touchstart', obj, false);

	//room4 
	obj.btn_o33.addEventListener('click', obj, false);
	obj.btn_o33.addEventListener('touchstart', obj, false);
	obj.btn_o34.addEventListener('click', obj, false);
	obj.btn_o34.addEventListener('touchstart', obj, false);
	obj.btn_o37.addEventListener('click', obj, false);
	obj.btn_o37.addEventListener('touchstart', obj, false);
	obj.btn_o38.addEventListener('click', obj, false);
	obj.btn_o38.addEventListener('touchstart', obj, false);	
	obj.btn_o39.addEventListener('click', obj, false);
	obj.btn_o39.addEventListener('touchstart', obj, false);	
	obj.btn_o40.addEventListener('click', obj, false);
	obj.btn_o40.addEventListener('touchstart', obj, false);	

	//room5
	obj.btn_o43.addEventListener('click', obj, false);
	obj.btn_o43.addEventListener('touchstart', obj, false);		
	obj.btn_o44.addEventListener('click', obj, false);
	obj.btn_o44.addEventListener('touchstart', obj, false);	

	//clear
	obj.btn_tweet.addEventListener('click', obj, false);
	obj.btn_tweet.addEventListener('touchstart', obj, false);	
	
}
function removeOptionListener(obj) {
	obj.btn_o1.removeEventListener('click', obj, false);
	obj.btn_o1.removeEventListener('touchstart', obj, false);
	obj.btn_o3.removeEventListener('click', obj, false);
	obj.btn_o3.removeEventListener('touchstart', obj, false);
	obj.btn_o4.removeEventListener('click', obj, false);
	obj.btn_o4.removeEventListener('touchstart', obj, false);
	obj.btn_o5.removeEventListener('click', obj, false);
	obj.btn_o5.removeEventListener('touchstart', obj, false);
	obj.btn_o6.removeEventListener('click', obj, false);
	obj.btn_o6.removeEventListener('touchstart', obj, false);
	obj.btn_o32.removeEventListener('click', obj, false);
	obj.btn_o32.removeEventListener('touchstart', obj, false);
	obj.btn_o41.removeEventListener('click', obj, false);
	obj.btn_o41.removeEventListener('touchstart', obj, false);	

	obj.btn_o7.removeEventListener('click', obj, false);
	obj.btn_o7.removeEventListener('touchstart', obj, false);
	obj.btn_o12.removeEventListener('click', obj, false);
	obj.btn_o12.removeEventListener('touchstart', obj, false);
	obj.btn_o13.removeEventListener('click', obj, false);
	obj.btn_o13.removeEventListener('touchstart', obj, false);
	obj.btn_o16.removeEventListener('click', obj, false);
	obj.btn_o16.removeEventListener('touchstart', obj, false);
	obj.btn_o17.removeEventListener('click', obj, false);
	obj.btn_o17.removeEventListener('touchstart', obj, false);
	obj.btn_o18.removeEventListener('click', obj, false);
	obj.btn_o18.removeEventListener('touchstart', obj, false);
	obj.btn_o23.removeEventListener('click', obj, false);
	obj.btn_o23.removeEventListener('touchstart', obj, false);
	obj.btn_o48.removeEventListener('click', obj, false);
	obj.btn_o48.removeEventListener('touchstart', obj, false);	

	obj.btn_o24.removeEventListener('click', obj, false);
	obj.btn_o24.removeEventListener('touchstart', obj, false);
	obj.btn_o25.removeEventListener('click', obj, false);
	obj.btn_o25.removeEventListener('touchstart', obj, false);
	obj.btn_o28.removeEventListener('click', obj, false);
	obj.btn_o28.removeEventListener('touchstart', obj, false);
	obj.btn_o29.removeEventListener('click', obj, false);
	obj.btn_o29.removeEventListener('touchstart', obj, false);

	obj.btn_o33.removeEventListener('click', obj, false);
	obj.btn_o33.removeEventListener('touchstart', obj, false);
	obj.btn_o34.removeEventListener('click', obj, false);
	obj.btn_o34.removeEventListener('touchstart', obj, false);
	obj.btn_o37.removeEventListener('click', obj, false);
	obj.btn_o37.removeEventListener('touchstart', obj, false);
	obj.btn_o38.removeEventListener('click', obj, false);
	obj.btn_o38.removeEventListener('touchstart', obj, false);	
	obj.btn_o39.removeEventListener('click', obj, false);
	obj.btn_o39.removeEventListener('touchstart', obj, false);	
	obj.btn_o40.removeEventListener('click', obj, false);
	obj.btn_o40.removeEventListener('touchstart', obj, false);	

	obj.btn_o43.removeEventListener('click', obj, false);
	obj.btn_o43.removeEventListener('touchstart', obj, false);		
	obj.btn_o44.removeEventListener('click', obj, false);
	obj.btn_o44.removeEventListener('touchstart', obj, false);	

	obj.btn_tweet.removeEventListener('click', obj, false);
	obj.btn_tweet.removeEventListener('touchstart', obj, false);	
}