var exeobj = Object();
function exe_root_1(obj) {
	console.log("exe_root_1");
	exeobj = obj;
	exeobj.test = 1;
	exeobj.stop();

	//テキストエリアを無効化
	document.getElementById("interLoading").style.display = "none";
	document.getElementById("loadingNumTextArea").value = "";
	document.getElementById("loadingNumArea").style.display = "none";
	document.getElementById("commentArea").style.display = "none";
	document.getElementById("commentTextArea").value = "";

	//名前
	exeobj.cegSessionKey = getCegSessionKey();
	exeobj.cegUserName   = getCegUserName();
	exeobj.cegPassword   = getCegPassword();
	exeobj.name_txt.text = "@" + exeobj.cegUserName;
	
	//サウンド
	exeobj.soundFlg = getCegSoundFlg(CEG_AID);
	exeobj.audios = loadSound();
	
	exeobj.tokenmiss = 0;
	
	//ハイスコアレコード（クリア日時）　＆　クリアフラグ
	exeobj.recordScore = displayRecord(exeobj.clear_score_mc, exeobj.clear_date_txt);

	exeobj.position = 0;

	//データロード
	exeobj = loadData(exeobj);

	//初期化
	exeobj.eventFlg = 0;
	exeobj.itemPosition = 0;
	exeobj.selectItem = NaN;
	exeobj.detailItem = NaN;
	exeobj.nowHintProgress = 0;
	//exeobj.items = DEFAULT_ITEMS;
	exeobj.getItemId = NaN;
	exeobj.getItemSound = NaN;
	exeobj.closeItemDetailTimeout = 0;
	exeobj.selectId = NaN;
	exeobj = formatForStart(exeobj);
	exeobj.blockCnt = 0;
	exeobj.optionEvent = 0;
	exeobj.fairyHand = NaN;//
	exeobj.playcount = 0;
	exeobj.eventMessage = false;

	//------test
	//deleteAllData(obj);
	
	addTopListener(exeobj);

	//test
	exeobj.btn_dummy_mc.visible = false;

	//体験版フラグ
	exeobj.trial_mc.visible = TRIAL_FLG;

	//ストップ
	exeobj.stop();
}

//ゲーム開始時初期化
function formatGameDisplay() {
	exeobj.map_mc.gotoAndStop(exeobj.position);
	exeobj.save_mc.gotoAndStop(0);
	exeobj.o45.gotoAndStop(0);
	if(exeobj.soundFlg != FLG_ON) {
    	exeobj.sound_mc.gotoAndStop(1);
    } else {
    	exeobj.sound_mc.gotoAndStop(0);
    }
	setTimeout(formatMc, 20);
}

function formatMc() {
	//unDisplayMovable(exeobj);
	formatMessage(exeobj);

	//アイテムセット
	setGameItems(exeobj, exeobj.itemPosition);
	
	//アイテム詳細削除
	unDisplayItemDetail(exeobj);

	//選択肢非表示
	unDisplaySelect(exeobj);

	//ルーム
	setRoom(exeobj);

	if(exeobj.gameEvents[E_GAME_FIRST] != 1) {
		var messages = FIRST_MESSAGES;
		displayMessage(exeobj, messages, 0, messages.length-1);
		exeobj.firstrt = 0;
		exeobj.rt_mc.visible = true;
		exeobj.eventFlg = 2;
		exeobj.gameEventId = 10;
		//exeobj.gameEvents[E_GAME_FIRST] = 1;
	}
	
	exeobj.blackout_mc.gotoAndPlay(1);
}

//ゲーム外からメッセージ押下
function onMessageOut() {
	onMessage(exeobj);
}

function onGallery(obj, num) {
	var formovieFlg = getCegFormovieFlg(CEG_AID);
	//立ち上げ
	document.getElementById("interGameEvent").style.display = "block";
	var imageFile = num + ".png";
	if(formovieFlg == FLG_ON) {
		if(num == 2 || num == 3 || num == 4 || num == 5 || num == 6) imageFile = "X.png";
	}
	var imgtag = document.getElementById("imagetag");
	$(imgtag).empty();
	$(imgtag).append("<img src=\"eventImages/"+imageFile+"?" + getDateString() +"\" style=\"width: 480px;\">");
}

function onSave(obj) {
	// (s)追加
	if(!isNaN(obj.getItemId)) {
		return;
	}
	// (e)追加
	if(TRIAL_FLG) {
		alert("体験版でSAVEはできません");
		return;
	}
	//セーブ
	obj = saveData(obj);
	//通信
	saveValueServer(obj);
	obj.save_mc.gotoAndPlay(1);
	displayInterItem(obj);
}

function onSound(obj) {
    if(obj.soundFlg != FLG_ON) {
    	obj.soundFlg = FLG_ON;
    	obj.sound_mc.gotoAndStop(0);
    } else {
    	obj.soundFlg = FLG_OFF;
    	obj.sound_mc.gotoAndStop(1);
    }
    setCegSoundFlg(CEG_AID, obj.soundFlg);

}

function onTop(obj) {
	// (s)追加
	if(!isNaN(obj.getItemId)) {
		return;
	}
	// (e)追加
    var result = window.confirm('TOPに戻るとセーブしたところに戻ります。よろしいですか？');
    
    if( result ) {
        removeGameListener(obj);
        obj.gotoAndStop(0);
        obj.setting_mc.gotoAndStop(0);
        obj.gallery_mc.gotoAndStop(0);
        //
        obj.gameEvents = DEFAULT_EVENTS;
        obj.gameEvents[E_LUMP_STATUS] = [0, 0, 0, 0, 0, 0];
        obj.items = DEFAULT_ITEMS;
        exeobj = obj;
        exe_root_1(obj);
    }
    else {
        
    }
}

function deleteAllData(obj) {
	obj.gameEvents = [];
	obj.items = DEFAULT_ITEMS;
	obj.lump_statuses = [0, 0, 0, 0, 0, 0];
	obj.medal_statuses = [0, 0, 0];
	obj.gameEvents[E_LUMP_STATUS] = obj.lump_statuses;
	obj.position = 0;
	obj.galleries = DEFAULT_GALLERIES;
	obj.clearRank = undefined;
	localStorage.removeItem("erotrap_gameevents");
	localStorage.removeItem("erotrap_items");
	localStorage.removeItem("erotrap_position");
	localStorage.removeItem("erotrap_galleries");
	localStorage.removeItem("erotrap_clear_rank");
	localStorage.removeItem("erotrap_recordscore");
	saveData(obj);
	exeobj = obj;
}

function onDeleteData(obj) {
	var result = window.confirm('セーブデータを削除して、最初からやり直しますか？　※ギャラリーとクリア日付は消えません。');
    
    if( result ) {
    	alert("セーブデータを削除しました");
    	obj.gameEvents = [];
    	obj.items = DEFAULT_ITEMS;
    	obj.lump_statuses = [0, 0, 0, 0, 0, 0];
    	obj.gameEvents[E_LUMP_STATUS] = obj.lump_statuses;
    	obj.medal_statuses = [0, 0, 0];
    	obj.position = 0;
        localStorage.removeItem("erotrap_gameevents");
		localStorage.removeItem("erotrap_items");
		localStorage.removeItem("erotrap_position");
		console.log("onDeleteData : " + obj.items);
		saveData(obj);
		exeobj = obj;
    }
    else {
        
    }
}

function displayGalleryIcon(obj) {
	var formovieFlg = getCegFormovieFlg(CEG_AID);
	console.log("formovieFlg="+formovieFlg);
	if(obj.galleries[0]) {
		obj.gallery_mc.gallery_frame_mc0.gotoAndStop(0);
		obj.gallery_mc.g0.visible = true;
	} else {
		obj.gallery_mc.gallery_frame_mc0.gotoAndStop(1);
		obj.gallery_mc.g0.visible = false;
	}
	if(obj.galleries[1]) {
		obj.gallery_mc.gallery_frame_mc1.gotoAndStop(0);
		obj.gallery_mc.g1.visible = true;
	} else {
		obj.gallery_mc.gallery_frame_mc1.gotoAndStop(1);
		obj.gallery_mc.g1.visible = false;
	}
	if(obj.galleries[2]) {
		obj.gallery_mc.gallery_frame_mc2.gotoAndStop(0);
		if(formovieFlg == FLG_ON) obj.gallery_mc.gallery_frame_mc2.gotoAndStop(2);
		obj.gallery_mc.g2.visible = true;
	} else {
		obj.gallery_mc.gallery_frame_mc2.gotoAndStop(1);
		obj.gallery_mc.g2.visible = false;
	}
	if(obj.galleries[3]) {
		obj.gallery_mc.gallery_frame_mc3.gotoAndStop(0);
		if(formovieFlg == FLG_ON)obj.gallery_mc.gallery_frame_mc3.gotoAndStop(2);
		obj.gallery_mc.g3.visible = true;
	} else {
		obj.gallery_mc.gallery_frame_mc3.gotoAndStop(1);
		obj.gallery_mc.g3.visible = false;
	}
	if(obj.galleries[4]) {
		obj.gallery_mc.gallery_frame_mc4.gotoAndStop(0);
		if(formovieFlg == FLG_ON)obj.gallery_mc.gallery_frame_mc4.gotoAndStop(2);
		obj.gallery_mc.g4.visible = true;
	} else {
		obj.gallery_mc.gallery_frame_mc4.gotoAndStop(1);
		obj.gallery_mc.g4.visible = false;
	}
	if(obj.galleries[5]) {
		obj.gallery_mc.gallery_frame_mc5.gotoAndStop(0);
		if(formovieFlg == FLG_ON)obj.gallery_mc.gallery_frame_mc5.gotoAndStop(2);
		obj.gallery_mc.g5.visible = true;
	} else {
		obj.gallery_mc.gallery_frame_mc5.gotoAndStop(1);
		obj.gallery_mc.g5.visible = false;
	}
	if(obj.galleries[6]) {
		obj.gallery_mc.gallery_frame_mc6.gotoAndStop(0);
		if(formovieFlg == FLG_ON)obj.gallery_mc.gallery_frame_mc6.gotoAndStop(2);
		obj.gallery_mc.g6.visible = true;
	} else {
		obj.gallery_mc.gallery_frame_mc6.gotoAndStop(1);
		obj.gallery_mc.g6.visible = false;
	}
	if(obj.galleries[7]) {
		obj.gallery_mc.gallery_frame_mc7.gotoAndStop(0);
		obj.gallery_mc.g7.visible = true;
	} else {
		obj.gallery_mc.gallery_frame_mc7.gotoAndStop(1);
		obj.gallery_mc.g7.visible = false;
	}
}

//ユーザ名変更からの戻り
function responseChangeCegUserName(userName, obj) {
	alert("名前を変更しました");
	obj.cegUserName = userName;
	obj.name_txt.text = "@" + obj.cegUserName;

	//ランキング反映通信
	tellName(CEG_AID, obj.cegSessionKey, userName, obj);

}
function errorChangeCegUserName(obj) {
	alert("名前の変更に失敗しました。通信状況をご確認ください。");
}

//名前変更
function tellName(aid, cegSessionKey, userName, obj) {
	console.log(URL_TELL_NAME + "?aid="+aid+"&sk="+cegSessionKey+"&un="+userName);
    $.ajax(URL_TELL_NAME, {
        type: 'post',
        dataType: 'json',
        data: {"aid": aid, "sk": cegSessionKey, "un": userName},
        timeout: 3000,
      }
    )
    // 通信成功
    .done(function(res) {
        //console.log('通信成功');
        //console.log(res);
        //console.log("XMLHttpRequest : " + JSON.stringify(res));
        responseTellName(obj);
    })
    // 通信失敗(タイムアウトまたはサーバエラー)
    .fail(function(XMLHttpRequest, textStatus, errorThrown) {
        //console.log("通信失敗");
        //console.log("XMLHttpRequest : " + JSON.stringify(XMLHttpRequest));
        //console.log("textStatus     : " + textStatus);
        //console.log("errorThrown    : " + errorThrown.message);
        errorTellName(obj);
    });
}

//ユーザ名変更からの戻り
function responseTellName(obj) {
	
}
function errorTellName(obj) {
	
}

//インステ表示
function displayInterItem(obj) {
	var r = getRandomInt(5);
	if(r==1) {
		
	} else if(r==2) {
		
	} 
}

function displayInterItem2(obj) {
	var r = getRandomInt(3);
	if(r==1) {
		
	} else if(r==2) {
		
	} 
}


