var connectFlg = false;
var page = 1;
var maxpage = 1;

//初期処理
function initRanking() {
    var objDate = new Date();
    var term = judgeTerm();
    connectTotal();
}

function nextpage() {
    page ++;
    if(page >= maxpage) page = maxpage;
    ajaxTotal();
}

function backpage() {
    page --;
    if(page <= 0) page = 1;
    ajaxTotal();
}

function connectTotal() {
	ajaxTotal();
}

function ajaxTotal() {
    if(connectFlg) return;
	var ranking = document.getElementById("ranking");
    $(ranking).empty();
    var sk = getCegSessionKey();
    connectFlg = true;
    console.log("URL_CLEAR_RANKING:" + URL_CLEAR_RANKING);
    console.log("aid:" + CEG_AID);
    console.log("sk:" + sk);
    console.log("pg:" + page);
    $.ajax(URL_CLEAR_RANKING + "?aid="+CEG_AID+"&sk="+sk+"&pg="+page+"&lm="+RANKING_LIMIT, {
        type: 'get',
        dataType: 'json',
        timeout: 3000,
      }
    )
    // 通信成功
    .done(function(res) {
        connectFlg = false;
        console.log("XMLHttpRequest : " + JSON.stringify(res));
        var cnt = res["cnt"];
        if(cnt == 0) {
            maxpage = 1;
        } else {
            maxpage = Math.ceil(cnt / RANKING_LIMIT);
        }
        
        var dom = "";
        dom += "<tr>";
    	dom += "<th scope=\"col\">ランク</th>";
    	dom += "<th scope=\"col\">名前</th>";
    	dom += "<th scope=\"col\">日付</th>";
    	dom += "</tr>";
        var term = judgeTerm();
        for(var i=0; i<RANKING_LIMIT; i++) {
            if(res["cegRankings"][i] == undefined) break;
        	if(res["cegRankings"][i]["mineFlg"]) {
                dom += "<tr style='background-color:#FCC'>";
            } else {
                dom += "<tr style='background-color:#FFF'>";
            }

        	dom += "<td scope=\"row\">";
        	dom += (i+1);
        	dom += "</td>";

        	dom += "<td scope=\"row\">";
        	dom += res["cegRankings"][i]["name"];
        	dom += "</td>";

        	dom += "<td scope=\"row\">";
            var dates = res["cegRankings"][i]["cleardate"].split(" ");
        	//dom += res["cegRankings"][i]["cleardate"];
            dom += dates[0] + "<br />" + dates[1];
        	dom += "</td>";

        	dom += "</tr>";

            
        }
        $(ranking).append(dom);

        //ページング
        var paging = document.getElementById("paging");
        $(paging).empty();
        var dom1 = "";
        
        dom1 += '<div class="container"><div class="row"><div class="col">';
        if(page == 1) {
            dom1 += '　';
        } else {
            dom1 += '<a href="javascript:void(0)" onClick="backpage()">　　　＜　　　</a>';
        }
        dom1 += '</div><div class="col">';
        dom1 += page + '/' + maxpage;
        dom1 += '</div><div class="col">';
        if(page >= maxpage) {
            dom1 += '　';
        } else {
            dom1 += '<a href="javascript:void(0)" onClick="nextpage()">　　　＞　　　</a>';
        }
        dom1 += '</div></div></div>';
        $(paging).append(dom1);

    })
    // 通信失敗(タイムアウトまたはサーバエラー)
    .fail(function(XMLHttpRequest, textStatus, errorThrown) {
        connectFlg = false;
        console.log("XMLHttpRequest : " + JSON.stringify(XMLHttpRequest));
        console.log("textStatus     : " + textStatus);
        console.log("errorThrown    : " + errorThrown.message);
        window.alert("通信失敗しました。通信のできる場所でプレイしてくださいね。");
        //再通信ボタン表示
    });
}
