//メッセージ押下
function onMessage(obj) {
	if((obj.nowProgress-1)*5 > obj.message.lengthB()) {
		if(obj.messagePage >= obj.messagePageMax) {
			formatMessage(obj);
			if(obj.eventFlg == 1) {
				displayGameEvent(obj);
			}
			if(obj.eventFlg == 2) {
				displaySubGameEvent(obj);
			}
		} else {
			obj.messagePage ++;
			obj.message = obj.messages[obj.messagePage];
			document.getElementById("commentTextArea").value = "　";
			obj.nowProgress = 0;
			obj.intervalMessageId = setInterval(onFrameMessage, INTERVAL_MESSAGE, obj);
			if(obj.messagePage == obj.getItemMessagePage && !isNaN(obj.getItemId)) {
				getItem(obj, obj.getItemId);
				if(!isNaN(obj.getItemSound)) playsound(obj, obj.getItemSound);
				obj.getItemId = NaN;
				obj.getItemSound = NaN;
			}
		}
	} else {
		obj.nowProgress = 999;
		document.getElementById("commentTextArea").value = obj.message;
	}
}

//コメント表示
function progressWord(obj) {
	obj.nowProgress ++;
	document.getElementById("commentTextArea").value = obj.message.substrB(0, obj.nowProgress*5);
	if((obj.nowProgress-1)*5 > obj.message.lengthB()) {
		document.getElementById("commentTextArea").blur();
		clearInterval(obj.intervalMessageId);
	}
}

//アイテム押下
function onItem(obj, itemDisplayId) {
	if(obj.eventFlg) return;
	if(!isNaN(obj.getItemId)) return;
	var index = Number(itemDisplayId)-1 + Number(obj.itemPosition);
	var itemTypeId = obj.itemDisplayIds[index];
	if(isNaN(itemTypeId)) return;
	if(isNaN(obj.selectItem)) {
		//選択する
		obj.selectItem = itemTypeId;
		setGameItems(obj, obj.itemPosition);
		//transItemIcon(obj, itemDisplayId, 1);
	} else {
		if(obj.selectItem == itemTypeId) {
			//選択中のアイテムをさらに押下
			if(obj.detailItem == itemTypeId) {
				//既に詳細に表示されている場合、選択解除・詳細解除
				obj.selectItem = NaN;
				transItemIcon(obj, itemDisplayId, 0);
				unDisplayItemDetail(obj);
			} else {
				if(!isNaN(obj.selectId)) return;
				//詳細に表示されていない
				obj.detailItem = itemTypeId;
				//詳細表示
				displayItemDetail(obj);
			}
		} else {
			//別アイテムを選択　＆　！詳細はそのまま
			//他を選択解除
			obj.selectItem = itemTypeId;
			setGameItems(obj, obj.itemPosition);
			/*
			obj.selectItem = itemTypeId;
			for(var i=1; i<=5; i++) {
				transItemIcon(obj, i, 0);
			}
			transItemIcon(obj, itemDisplayId, 1);
			*/
		}
	}
	displayTutorial(obj);
	
}

function transItemIcon(obj, itemDisplayId, frame) {
	if(itemDisplayId==1) obj.id_mc1.gotoAndStop(frame);
	if(itemDisplayId==2) obj.id_mc2.gotoAndStop(frame);
	if(itemDisplayId==3) obj.id_mc3.gotoAndStop(frame);
	if(itemDisplayId==4) obj.id_mc4.gotoAndStop(frame);
	if(itemDisplayId==5) obj.id_mc5.gotoAndStop(frame);
}

//アイテム表示セット(0)
function setGameItems(obj, position) {
	obj.id_mc1.gotoAndStop(2);
	obj.id_mc2.gotoAndStop(2);
	obj.id_mc3.gotoAndStop(2);
	obj.id_mc4.gotoAndStop(2);
	obj.id_mc5.gotoAndStop(2);
	var ei = [NaN, NaN, NaN, NaN, NaN];
	var index = 0;//個数
	for(var i=0; i<ITEM_COUNT; i++) {
		if(obj.items[i] == 1) {
			ei[index] = i;
			index ++;
		}
	}

	if(!isNaN(ei[0+position])) {
		obj.id_mc1.gotoAndStop(0);
		if(obj.selectItem == ei[0+position]) obj.id_mc1.gotoAndStop(1);
		obj.id_mc1.item_mc.gotoAndStop(ei[0+position]);
	}
	if(!isNaN(ei[1+position])) {
		obj.id_mc2.gotoAndStop(0);
		if(obj.selectItem == ei[1+position]) obj.id_mc2.gotoAndStop(1);
		obj.id_mc2.item_mc.gotoAndStop(ei[1+position]);
	}
	if(!isNaN(ei[2+position])) {
		obj.id_mc3.gotoAndStop(0);
		if(obj.selectItem == ei[2+position]) obj.id_mc3.gotoAndStop(1);
		obj.id_mc3.item_mc.gotoAndStop(ei[2+position]);
	}
	if(!isNaN(ei[3+position])) {
		obj.id_mc4.gotoAndStop(0);
		if(obj.selectItem == ei[3+position]) obj.id_mc4.gotoAndStop(1);
		obj.id_mc4.item_mc.gotoAndStop(ei[3+position]);
	}
	if(!isNaN(ei[4+position])) {
		obj.id_mc5.gotoAndStop(0);
		if(obj.selectItem == ei[4+position]) obj.id_mc5.gotoAndStop(1);
		obj.id_mc5.item_mc.gotoAndStop(ei[4+position]);
	}

	obj.ic_l.visible = position > 0;
	obj.ic_r.visible = position+5 < index;

	obj.itemDisplayIds = ei;
	obj.itemKindCount = index;
}

function formatSelectItem(obj) {
	obj.selectId = NaN;
	obj.selectItem = NaN;
	obj.id_mc1.gotoAndStop(0);
	obj.id_mc2.gotoAndStop(0);
	obj.id_mc3.gotoAndStop(0);
	obj.id_mc4.gotoAndStop(0);
	obj.id_mc5.gotoAndStop(0);
}

function resetData(obj) {
	obj.gameEvents = DEFAULT_EVENTS;
	obj.items = DEFAULT_ITEMS;
	obj.position = 0;
	saveData(obj);
	resetDisplay();
}

//データセーブ
function saveData(obj) {
	obj.gameEvents[E_LUMP_STATUS] = obj.lump_statuses;
	var gameEventJson = JSON.stringify(obj.gameEvents);
	localStorage.setItem("erotrap_gameevents", gameEventJson);
	var itemJson = JSON.stringify(obj.items);
	localStorage.setItem("erotrap_items", itemJson);
	localStorage.setItem("erotrap_position", obj.position);
	var galleryJson = JSON.stringify(obj.galleries);
	localStorage.setItem("erotrap_galleries", galleryJson);
	return obj;
}

function saveGalleryData(obj) {
	var galleryJson = JSON.stringify(obj.galleries);
	localStorage.setItem("erotrap_galleries", galleryJson);
}

//データロード
function loadData(obj) {
	//フラグ
	var gameEvents = localStorage.getItem("erotrap_gameevents");
	if(gameEvents == undefined || gameEvents == null || gameEvents == "") {
		obj.gameEvents = DEFAULT_EVENTS;
		obj.lump_statuses = [0, 0, 0, 0, 0, 0];
		obj.medal_statuses = [0, 0, 0];
		obj.gameEvents[E_LUMP_STATUS] = obj.lump_statuses;
		var gameEventJson = JSON.stringify(obj.gameEvents);
		localStorage.setItem("erotrap_gameevents", gameEventJson);
	} else {
		obj.gameEvents = JSON.parse(gameEvents);
	}
	
	//アイテム
	var items = localStorage.getItem("erotrap_items");
	if(items == undefined || items == null || items == "") {
		obj.items = DEFAULT_ITEMS;
		var itemJson = JSON.stringify(obj.items);
		localStorage.setItem("erotrap_items", itemJson);
	} else {
		obj.items = JSON.parse(items);
	}

	//場所
	var position = localStorage.getItem("erotrap_position");
	if(position == undefined || position == null || position == "") {
		obj.position = DEFAULT_POSITION;
		localStorage.setItem("erotrap_position", obj.position);
	} else {
		obj.position = Number(position);
	}

	//ギャラリー
	var galleries = localStorage.getItem("erotrap_galleries");
	if(galleries == undefined || galleries == null || galleries == "") {
		obj.galleries = DEFAULT_GALLERIES;
		var galleryJson = JSON.stringify(obj.galleries);
		localStorage.setItem("erotrap_galleries", galleryJson);
	} else {
		obj.galleries = JSON.parse(galleries);
	}

	//クリアランク
	var clearRank = localStorage.getItem("erotrap_clear_rank");
	if(clearRank == undefined || clearRank == null || clearRank == "") {
		localStorage.setItem("erotrap_clear_rank", obj.clearRank);
	} else {
		obj.clearRank = clearRank;
	}
	return obj;
}

//アイテム詳細表示
function displayItemDetail(obj) {
	obj.btn_itemdetail_close.visible = true;
	obj.item_window_mc.item_detail_close_mc.visible = true;
	obj.btn_item_detail.visible = true;
	obj.item_window_mc.visible = true;
	obj.item_window_mc.item_mc.gotoAndStop(obj.detailItem);
	//メッセージ
	var messages = ["【" + ITEM_TYPES[obj.detailItem][1] + "】\r" + ITEM_TYPES[obj.detailItem][2]];
	displayMessage(obj, messages, 0, 0);
	clearTimeout(obj.timeItemDetailId);
	displayTutorial(obj);
	/*
	obj.nowProgress = 0;
	obj.messagePage = 0;
	obj.messagePageMax = 0;
	obj.message = ITEM_TYPES[obj.detailItem][2];
	obj.messages[0] = ITEM_TYPES[obj.detailItem][2];
	document.getElementById("commentArea").style.display = "block";
	obj.intervalMessageId = setInterval(onFrameMessage, INTERVAL_MESSAGE, obj);
	*/
}

//アイテム詳細　：　メッセージなし　：　一定時間で閉じる
function displayItemDetail2(obj) {
	obj.btn_itemdetail_close.visible = false;
	obj.item_window_mc.visible = true;
	obj.btn_item_detail.visible = true;
	obj.item_window_mc.item_detail_close_mc.visible = false;
	obj.item_window_mc.item_mc.gotoAndStop(obj.detailItem);
	obj.closeItemDetailTimeout = 1;
	obj.timeItemDetailId = setTimeout(closeItemDetail, 1800, obj);
}

function closeItemDetail(obj) {
	if(obj.closeItemDetailTimeout == 1) {
		unDisplayItemDetail(obj);
	}
}

//アイテム詳細を解除
function unDisplayItemDetail(obj) {
	if(obj.eventFlg) return;
	if(!isNaN(obj.getItemId)) return;
	obj.closeItemDetailTimeout = 0;
	clearTimeout(obj.timeItemDetailId);
	obj.detailItem = NaN;
	obj.item_window_mc.visible = false;
	obj.btn_itemdetail_close.visible = false;
	obj.btn_item_detail.visible = false;
	formatMessage(obj);
	displayTutorial(obj);
}

//メッセージ表示
function displayMessage(obj, messages, messagePage, messagePageMax) {
	obj.message_box_mc.visible = true;
	obj.nowProgress = 0;
	obj.messagePage = messagePage;
	obj.messagePageMax = messagePageMax;
	obj.messages = messages;
	obj.message = messages[0];
	document.getElementById("commentArea").style.display = "block";
	obj.intervalMessageId = setInterval(onFrameMessage, INTERVAL_MESSAGE, obj);
}

function formatMessage(obj) {
	obj.btn_message.visible = false;
	obj.message_box_mc.visible = false;
	obj.message = "";
	obj.eventMessage = false;
	document.getElementById("commentTextArea").value = "　";
	document.getElementById("commentArea").style.display = "none";
	clearInterval(obj.intervalMessageId);
	if(obj.firstrt == 0) {
		obj.firstrt = 1;
		obj.rt_mc.visible = false;
	}
}

function unDisplayMovable(obj) {
	obj.rc_r.visible = false;
	obj.rc_l.visible = false;
	obj.rc_t.visible = false;
	obj.rc_d.visible = false;
	obj.btn_move_r.visible = false;
	obj.btn_move_l.visible = false;
	obj.btn_move_t.visible = false;
	obj.btn_move_d.visible = false;
}

function setRoom(obj) {
	resetOption(obj);

	//移動visible 上右下左
	unDisplayMovable(obj);
	var movables = getMovableRoom(obj);
	if(!isNaN(movables[0])) {
		obj.rc_t.visible = true;
		obj.btn_move_t.visible = true;
	}
	if(!isNaN(movables[1])) {
		obj.rc_r.visible = true;
		obj.btn_move_r.visible = true;
	}
	if(!isNaN(movables[2])) {
		obj.rc_d.visible = true;
		obj.btn_move_d.visible = true;
	}
	if(!isNaN(movables[3])) {
		obj.rc_l.visible = true;
		obj.btn_move_l.visible = true;
	}
}

function resetOption(obj) {
	unVisibleOption(obj);
	visibleOption(obj);
}

//移動します　0123上右下左
function onMove(obj, direction) {
	if(obj.optionEvent == 1) obj.optionEvent = 0;
	if(obj.eventFlg) return;
	if(!isNaN(obj.selectId)) return;
	var movables = getMovableRoom(obj);
	if(isNaN(movables[direction])) return;
	playsound(obj, 0);
	var oldPosition = obj.position;
	obj.position = movables[direction];
	setRoom(obj);
	//演出
	setMoveEffect(obj, oldPosition, obj.position);
}

function resetDisplay(obj) {
	setRoom(obj);
	setGameItems(obj, obj.itemPosition);
}

//---------------

//音を出します
function playsound(obj, soundKey) {
    if(obj.soundFlg != FLG_ON) return;
    //音量
    if(soundKey==1) {
        obj.audios[soundKey].volume = 0.3;
    }
    if(soundKey==10) {
        obj.audios[soundKey].volume = 0.1;
    }
    if(soundKey==9) {
    	obj.audios[soundKey].volume = 0.1;
    }
    obj.audios[soundKey].play();
}

function stopsound(obj, soundKey) {
    obj.audios[soundKey].pause() ;
    obj.audios[soundKey].currentTime = 0 ;
}

function displayGameEvent(obj) {
	playsound(obj, 3);
	document.getElementById("interGameEvent").style.display = "block";
	obj.galleries[obj.gameEventId] = 1;
	saveGalleryData(obj);
	var formovieFlg = getCegFormovieFlg(CEG_AID);
	var imageFile = obj.gameEventId + ".png";
	if(formovieFlg == FLG_ON) {
		var num = obj.gameEventId;
		if(num == 2 || num == 3 || num == 4 || num == 5 || num == 6) imageFile = "X.png";
	}
	var imgtag = document.getElementById("imagetag");
	$(imgtag).empty();
	$(imgtag).append("<img src=\"eventImages/"+imageFile+"?" + getDateString() +"\" style=\"width: 480px;\">");
	obj.eventFlg = 0;
	setTimeout(gameEventAfter, 1000, obj);
}

function unDisplayGameEvent(obj) {
	document.getElementById("interGameEvent").style.display = "none";
}

function gameEventAfter(obj) {
	displayInterItem2(obj);
}

//maxを含まない
function getRandomInt(max) {
	return Math.floor(Math.random() * Math.floor(max));
}

//サウンドを一旦読み込みます
function loadSound() {
    var audioTimes = new Array();
    var audios = new Array();
    if(DL_FLG) {
        for(var i=0; i<SOUND_FILE.length; i++) {
            var soundFileName = SOUND_FILE[i];
            audios[i] = new Audio();
            audios[i].src = "sound/" + soundFileName + ".mp3"; 
            audios[i].load();
            audios[i].filename = soundFileName;
            //if(i==0) audios[i].loop = true;//bgm
            //音量
        }
    } else {
        for(var i=0; i<SOUND_FILE2.length; i++) {
            var soundFileName = SOUND_FILE2[i];
            audios[i] = new Audio();
            audios[i].src = "sound/" + soundFileName + ".mp3"; 
            audios[i].load();
            audios[i].filename = soundFileName;
            //if(i==0) audios[i].loop = true;//bgm
            //音量
        }
    }
    
    return audios;
}

//記録の表示
function displayRecord(record_text_mc, record_txt) {
    var recordScore = localStorage.getItem("erotrap_recordscore");
    if(recordScore == undefined || recordScore == null || recordScore == "" || recordScore == "0") {
        localStorage.setItem("erotrap_recordscore", "");
        record_text_mc.visible = false;
        record_txt.text = "";
    } else {
        record_text_mc.visible = true;
        record_txt.text = recordScore;
    }
    return recordScore;
}


String.prototype.lengthB = function() {
    var len = 0;
    for (var i = 0; i < this.length; i++) {
    if (this.charAt(i).isMultibyte()) {
    len += 2;
    } else {
    len += 1;
    }
    }
    return len;
}

String.prototype.substrB = function() {
    var fromByte = arguments[0];
    var retByte = arguments[1];

    // 開始位置の検索
    var len = 0;
    var i;
    for (i = 0; fromByte > len; i++) {
        if (this.charAt(i).isMultibyte()) {
            len += 2;
        } else {
            len += 1;
        }
    }
    var from = i;

    len = 0;
    var retLen = 0;
    while(retByte > len) {
        if (this.charAt(i).isMultibyte()) {
            len = len + 2;
        } else {
            len = len + 1;
        }
        retLen++;
        i++;
    }
    return this.substr(from, retLen);
}
String.prototype.isMultibyte = function() {
    var c = this.charCodeAt(0);
    // 半角の範囲
    // Unicode : 0x0 ～ 0x80, 0xf8f0, 0xff61 ～ 0xff9f, 0xf8f1 ～ 0xf8f3
    if ((c >= 0x0 && c <= 0x80) || (c == 0xf8f0) || (c >= 0xff61 && c <= 0xff9f) || (c >= 0xf8f1 && c <= 0xf8f3)) {
        return false;
    } else {
        return true;
    }
}

function stopsound(obj, soundKey) {
    obj.audios[soundKey].pause() ;
    obj.audios[soundKey].currentTime = 0 ;
}

function resZeroUndefined(value) {
    if(value == undefined || value == null || value==0 || isNaN(value)) return 0;
    return value;
}

function saveValueServer(obj) {
    if(!checkOnline) return;
    //サーバへ保存
    var valueobj = new Object();
    valueobj["recordScore"] = obj.recordScore;
    valueobj["gameEvents"] = obj.gameEvents;
    valueobj["items"] = obj.items;
    valueobj["position"] = obj.position;
    valueobj["galleries"] = obj.galleries;
    var value = JSON.stringify(valueobj);
    saveValue(CEG_AID, obj.cegSessionKey, value, obj);
}

function getCheckstr(obj) {
	var result = "";
	for(var i=0; i<obj.items.length; i++) {
		result += obj.items[i];
	}
	//result += "_";
	for(var i=0; i<6; i++) {
		result += resZeroUndefined(obj.lump_statuses[i]);
	}
	result += obj.gameEvents[E_PICK_PAPER] + obj.gameEvents[E_FIRE_PAPER];
	return result;
}

//9桁
function setNumberMc9(numberMc, number) {
    if(number<0) number = 0;
    
    var d9 = Math.floor(number/100000000);
    var d8 = Math.floor((number - d9*100000000) / 10000000);
    var d7 = Math.floor((number - d9*100000000 - d8*10000000) / 1000000);
    var d6 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000) / 100000);
    var d5 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000) / 10000);
    var d4 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000 - d5*10000) / 1000);
    var d3 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000 - d5*10000 - d4*1000) / 100);
    var d2 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000 - d5*10000 - d4*1000 - d3*100) / 10);
    var d1 = number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000 - d5*10000 - d4*1000 - d3*100 - d2*10;

    if(d9 == 0) {
        numberMc.unit9.gotoAndStop(11);
    } else {
        numberMc.unit9.gotoAndStop(d9+1);
    }
    if(d8 == 0 && d9==0) {
        numberMc.unit8.gotoAndStop(11);
    } else {
        numberMc.unit8.gotoAndStop(d8+1);
    }
    if(d7 == 0 && d8==0 && d9==0) {
        numberMc.unit7.gotoAndStop(11);
    } else {
        numberMc.unit7.gotoAndStop(d7+1);
    }
    if(d6 == 0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit6.gotoAndStop(11);
    } else {
        numberMc.unit6.gotoAndStop(d6+1);
    }
    if(d5 == 0 && d6==0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit5.gotoAndStop(11);
    } else {
        numberMc.unit5.gotoAndStop(d5+1);
    }
    if(d4 == 0 && d5==0 && d6==0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit4.gotoAndStop(11);
    } else {
        numberMc.unit4.gotoAndStop(d4+1);
    }
    if(d3 == 0 && d4==0 && d5==0 && d6==0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit3.gotoAndStop(11);
    } else {
        numberMc.unit3.gotoAndStop(d3+1);
    }
    if(d2 == 0 && d3==0 && d4==0 && d5==0 && d6==0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit2.gotoAndStop(11);
    } else {
        numberMc.unit2.gotoAndStop(d2+1);
    }
    numberMc.unit1.gotoAndStop(d1+1);
    if(d9==0 && d8==0 && d7==0 && d6==0 && d5==0 && d4==0) {
        numberMc.c1.visible = false;
        numberMc.c2.visible = false;
    } else if(d9==0 && d8==0 && d7==0) {
        numberMc.c1.visible = true;
        numberMc.c2.visible = false;
    } else {
        numberMc.c1.visible = true;
        numberMc.c2.visible = true;
    }
}

function getCegFormovieFlg(aid) {
    var result = localStorage.getItem("ceg_formovie1_" + aid);
    if(result == undefined || result == null) {
        result = 0;
        localStorage.setItem( "ceg_formovie1_" + aid, result);
    }
    return result;
}

function setCegFormovieFlg(aid, value) {
    localStorage.setItem( "ceg_formovie1_" + aid, value);
}

function displayFormovieCheck(obj) {
	var check = getCegFormovieFlg(CEG_AID);
	console.log("check=" + check);
	if(check==0) {
		obj.setting_mc.for_movie_mc.check_mc.visible = false;
	} else {
		obj.setting_mc.for_movie_mc.check_mc.visible = true;
	}
	
}

function changeFormovie(obj) {
	var check = getCegFormovieFlg(CEG_AID);
	if(check==0) {
		check = 1;
	} else {
		check = 0;
	}
	setCegFormovieFlg(CEG_AID, check);
	if(check==0) {
		obj.setting_mc.for_movie_mc.check_mc.visible = false;
	} else {
		obj.setting_mc.for_movie_mc.check_mc.visible = true;
	}
}


const checkOnline = async () => {
  const date = new Date();
  const timestamp = date.getTime();

  try {
    await fetch(`/favicon.ico?${timestamp}`);
  } catch {
    return false;
  }

  return true;
};


