//スタート時のフォーマット
function formatForStart(obj) {
	if(obj.gameEvents[E_PICK_POTION] == 1) ITEM_TYPES[3][2] = "さびていて使えそうにない。この状態で聖水をかけてみよう。";
	if(obj.gameEvents[E_LUMP_STATUS] != undefined) {
		obj.lump_statuses = obj.gameEvents[E_LUMP_STATUS];
	} else {
		obj.lump_statuses = [0, 0, 0, 0, 0, 0];
	}
	if(obj.gameEvents[E_MEDAL_STATUS] != undefined) {
		obj.medal_statuses = obj.gameEvents[E_MEDAL_STATUS];
	} else {
		obj.medal_statuses = [0, 0, 0];
	}
	return obj;
}

//アイテム詳細押下
function onItemDetail(obj) {
	//if(!isNaN(obj.getItemId)) return;
	if(obj.eventMessage) {
		onMessage(obj);
		return;
	}
	switch(obj.detailItem) {
		case 0:
			break;
		case 1:
			if(obj.selectItem == 9) {
				obj.eventMessage = true;
				var messages = ["生肉にファイアーロッドを使った！", "こんがり焼けました！"];
				displayMessage(obj, messages, 0, messages.length-1);
				obj.getItemId = 2;
				obj.getItemMessagePage = 1;
				obj.items[1] = 0;
				updateGameEvent(obj, E_FIRE_MEAT);
				obj.getItemSound = 4;
			}
			break;
		case 2:
			break;
		case 3:
			if(obj.selectItem == 0) {
				obj.eventMessage = true;
				var messages = ["さびたカギに聖水を使った！", "カギは輝きを取り戻し、赤いカギになった！"];
				displayMessage(obj, messages, 0, messages.length-1);
				obj.tutorial_mc.visible = false;
				obj.getItemId = 4;
				obj.getItemMessagePage = 1;
				obj.items[3] = 0;
				obj.items[0] = 0;
				updateGameEvent(obj, E_GET_KEY1);
				obj.getItemSound = 4;

				/*
				obj.detailItem = 4;
				displayItemDetail2(obj);
				obj.items[obj.detailItem] = 1;
				obj.items[3] = 0;
				obj.gameEvents[E_GET_KEY1] = 1;
				resetDisplay(obj);
				*/
			}
			break;




		default:
	}
	unDisplayItemDetail(obj);
}

function getItem(obj, id) {
	obj.detailItem = id;
	displayItemDetail2(obj);
	obj.items[obj.detailItem] = 1;
	resetDisplay(obj);
}

//オプション押下
function onOption(obj, num) {
	console.log("onOption num=" + num);
	if(obj.eventMessage) {
		onMessage(obj);
		return;
	}
	if(obj.eventFlg) return;
	if(!isNaN(obj.detailItem)) return;
	if(!isNaN(obj.getItemId)) return;
	if(!isNaN(obj.selectId)) return;
	switch(obj.position) {
		case 0:
			if(num == 1) {
				if(obj.gameEvents[E_USE_KEY1] == 1) {
					obj.eventMessage = true;
					var messages = ["ドアの先に行けるね。上の矢印で移動しよう。"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else {
					if(obj.selectItem == 3) {
						obj.eventMessage = true;
						var messages = ["カギ穴は合っていそうだけど、さびついて回らないや。", "このカギをきれいに磨きたいな"];
						displayMessage(obj, messages, 0, messages.length-1);
					} else if(obj.selectItem == 4) {
						obj.eventMessage = true;
						var messages = ["赤いカギを使った！", "ドアが開いた！"];
						displayMessage(obj, messages, 0, messages.length-1);
						updateGameEvent(obj, E_USE_KEY1);
						resetDisplay(obj);
						obj.selectItem = NaN;

						playsound(obj, 5);
					} else {
						if(obj.gameEvents[E_PICK_KEY0] == 1) {
							var messages = ["カギを選択して使ってみよう"];
							displayMessage(obj, messages, 0, messages.length-1);
						} else {
							var messages = ["カギがかかっている"];
							displayMessage(obj, messages, 0, messages.length-1);
						}
					}
				}
			}

			break;
		case 1:
			if(num == 3) {
				if(obj.gameEvents[E_BREAK_POD1] == 1) {
					return;
				}
				if(obj.selectItem == 11 && obj.gameEvents[E_FIRE_POD] != 1) {
					obj.eventMessage = true;
					var messages = ["ハンマーでツボをたたいた！", "ツボの中から触手が現れ、襲いかかってきた！"];
					displayMessage(obj, messages, 0, messages.length-1);
					obj.eventFlg = 1;
					obj.gameEventId = 2;
					return;
				} else if(obj.selectItem == 11 && obj.gameEvents[E_FIRE_POD] == 1 && obj.gameEvents[E_BREAK_POD1] != 1) {
					obj.eventMessage = true;
					var messages = ["ハンマーでツボをたたいた！", "ツボは粉々に砕けた！"];
					displayMessage(obj, messages, 0, messages.length-1);
					updateGameEvent(obj, E_BREAK_POD1);
					obj.eventFlg = 2;
					obj.gameEventId = 4;
				} else if(obj.selectItem == 9 && obj.gameEvents[E_FIRE_POD] != 1) {
					updateGameEvent(obj, E_FIRE_POD);
					obj.eventMessage = true;
					var messages = ["ファイアーロッドを使った！", "触手に38のダメージ！触手をやっつけた！"];
					displayMessage(obj, messages, 0, messages.length-1);
					obj.eventFlg = 2;
					obj.gameEventId = 9;
					return;
				} else if(obj.gameEvents[E_FIRE_POD] != 1) {
					obj.eventMessage = true;
					var messages = ["ツボを調べた", "ツボの中身はエロ触手だった！"];
					displayMessage(obj, messages, 0, messages.length-1);
					obj.eventFlg = 1;
					obj.gameEventId = 2;
				} else if(obj.gameEvents[E_FIRE_POD] == 1) {
					obj.eventMessage = true;
					var messages = ["ツボを調べた", "しかしなにも見つからなかった"];
					displayMessage(obj, messages, 0, messages.length-1);
				}
				
			} else if(num == 4) {
				if(obj.gameEvents[E_PICK_POTION] == 1) {
					if(obj.selectItem == 11 && obj.gameEvents[E_BREAK_POD2] != 1) {
						obj.eventMessage = true;
						var messages = ["ハンマーでツボをたたいた！", "ツボは粉々に砕けた！"];
						displayMessage(obj, messages, 0, messages.length-1);
						updateGameEvent(obj, E_BREAK_POD2);
						obj.eventFlg = 2;
						obj.gameEventId = 4;
					} else {
						obj.eventMessage = true;
						var messages = ["ツボを調べた", "しかしなにも見つからなかった"];
						displayMessage(obj, messages, 0, messages.length-1);
					}
					
				} else {
					obj.eventMessage = true;
					var messages = ["ツボを調べた", "聖水を手に入れた！"];
					displayMessage(obj, messages, 0, messages.length-1);
					obj.getItemId = 0;
					obj.getItemMessagePage = 1;
					updateGameEvent(obj, E_PICK_POTION);
					obj.getItemSound = 1;
					ITEM_TYPES[3][2] = "さびていて使えそうにない。この状態で聖水をかけてみよう。";
				}
				
				//メッセージなしでGET
				//getItem(obj, 0);
			} else if(num == 5) {
				if(obj.gameEvents[E_PICK_MEAT1] == 1) {
					if(obj.selectItem == 11 && obj.gameEvents[E_BREAK_POD3] != 1) {
						obj.eventMessage = true;
						var messages = ["ハンマーでツボをたたいた！", "ツボは粉々に砕けた！"];
						displayMessage(obj, messages, 0, messages.length-1);
						updateGameEvent(obj, E_BREAK_POD3);
						obj.eventFlg = 2;
						obj.gameEventId = 4;
					} else {
						obj.eventMessage = true;
						var messages = ["ツボを調べた", "しかしなにも見つからなかった"];
						displayMessage(obj, messages, 0, messages.length-1);
					}
				} else {
					obj.eventMessage = true;
					var messages = ["ツボを調べた", "生肉を手に入れた！"];
					displayMessage(obj, messages, 0, messages.length-1);
					obj.getItemId = 1;
					obj.getItemMessagePage = 1;
					updateGameEvent(obj, E_PICK_MEAT1);
					obj.getItemSound = 1;
				}
			}

			if(num == 6) {
				if(obj.gameEvents[E_PICK_MEDAL1] != 1 && obj.gameEvents[E_BREAK_POD1] == 1) {
					updateGameEvent(obj, E_PICK_MEDAL1);
					var messages = ["赤いメダルを拾った！"];
					displayMessage(obj, messages, 0, messages.length-1);
					getItem(obj, 15);
					playsound(obj, 1);
				}
			}

			break;
		case 2:
			if(num == 6) {
				if(obj.gameEvents[E_PICK_KEY0] != 1) {
					updateGameEvent(obj, E_PICK_KEY0);
					var messages = ["さびたカギを拾った！"];
					displayMessage(obj, messages, 0, messages.length-1);
					getItem(obj, 3);
					playsound(obj, 1);
				}
			}

			if(num == 32) {
				if(obj.gameEvents[E_SLEEP_FAIRY1] != 1) {
					if(obj.selectItem == 13) {
						obj.eventMessage = true;
						var messages = ["眠り姫のオルゴールを使った！", "フォロを眠らせた！"];
						displayMessage(obj, messages, 0, messages.length-1);
						obj.eventFlg = 2;
						obj.gameEventId = 7;
						updateGameEvent(obj, E_SLEEP_FAIRY1);
						return;
					}
				}

				if(obj.gameEvents[E_OPEN_DOOR5] == 1) {
					if(obj.gameEvents[E_SLEEP_FAIRY2] == 1 && obj.gameEvents[E_SLEEP_FAIRY3] == 1 && obj.gameEvents[E_SLEEP_GOBLIN] == 1) {
						obj.eventMessage = true;
						var messages = ["フォロ「クリアおめでとう！私からご褒美をあげるわ。」", "フォロはあたりの気配を探った。", "＊「みんな寝ているようね。ふふふ。ご褒美は『乳首責め』よ！」"];
						displayMessage(obj, messages, 0, messages.length-1);
						obj.eventFlg = 1;
						obj.gameEventId = 6;
						return;
					} else {
						obj.eventMessage = true;
						var messages = ["フォロ「クリアおめでとう！私の見込んだ通りだわ。」", "フォロはあたりの気配を探った。", "＊「・・・。ご褒美をあげたいところだけど、それはまた今後にするわ。」"];
						displayMessage(obj, messages, 0, messages.length-1);
						return;
					}
				}

				if(obj.gameEvents[E_GET_KEY1] != 1) {
					obj.eventMessage = true;
					var messages = ["妖精「あら、あなたここのダンジョンははじめてかしら？」", "＊「私はお助け妖精の『フォロ』。みんなに内緒で少しだけヒントをあげるわね。」", "＊「アイテムを選択してもう一度タップすると大きく表示されるわ。」", "＊「その状態で別のアイテムをそのアイテムに使うことができるのよ。覚えておきなさいね。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else if(obj.selectItem == 1) {
					obj.eventMessage = true;
					var messages = ["フォロ「アイテムを選択してもう一度タップすると大きく表示されるわ。」", "＊「その状態で別のアイテムをそのアイテムに使うことができるのよ。よく覚えておきなさいね。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else if(obj.selectItem == 7) {
					obj.eventMessage = true;
					var messages = ["フォロ「ん？ああ、それで釣りでもするのかしら。」", "＊「釣りは根気が重要よね。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else if(obj.selectItem == 9) {
					obj.eventMessage = true;
					var messages = ["フォロ「それはファイアーロッドね。私たち妖精にはきかないわね。」", "＊「モンスターを倒すだけじゃなくて、他の使い方も考えてみて。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else if(obj.selectItem == 11) {
					obj.eventMessage = true;
					var messages = ["フォロ「そのハンマーを使うとツボが破壊できるわよ。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else if(obj.playcount > 50 && obj.gameEvents[E_WIN_FAIRY] != 1) {
					obj.eventMessage = true;
					var messages = ["フォロ「ねえあなた。後出しって知ってるかしら？」", "＊「私は中出ししか知らないわ」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else if(obj.playcount > 5 && obj.gameEvents[E_WIN_FAIRY] != 1) {
					obj.eventMessage = true;
					var messages = ["フォロ「このエロトラップダンジョンを攻略するなら、ときにはズルいことも必要よね。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else {
					var r = getRandomInt(2);
					if(r==1) {
						obj.eventMessage = true;
						var messages = ["フォロ「へえー。あなた、なかなか見どころがありそうね。」", "＊「この先にも(えっちな)仕掛けがあるから、気をつけて頑張ってね。」"];
						displayMessage(obj, messages, 0, messages.length-1);
					} else {
						obj.eventMessage = true;
						var messages = ["フォロ「アイテムを選択してもう一度タップすると大きく表示されるわ。」", "＊「その状態で別のアイテムをそのアイテムに使うことができるのよ。覚えておきなさいね。」", "＊「そして、クリアしたら私に報告するのよ。いいわね？」"];
						displayMessage(obj, messages, 0, messages.length-1);
					}
					
				}
				
				
			}

			if(num == 41) {
				var r = getRandomInt(3);
				if(r==0) {
					obj.eventMessage = true;
					var messages = ["＊「すやすや・・・。ブロックはメダルをもっているわ・・・むにゃむにゃ・・・。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else if(r==1) {
					obj.eventMessage = true;
					var messages = ["＊「すやすや・・・。触手のつぼの下にはメダルがあるわ・・・むにゃむにゃ・・・。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				} else {
					obj.eventMessage = true;
					var messages = ["＊「すやすや・・・。羊紙皮には特殊な液体で文字が書いてあるわ・・・むにゃむにゃ・・・。」"];
					displayMessage(obj, messages, 0, messages.length-1);
				}
			}


			break;

		//------------------------------------------------------------------


		default:
	}
}

function onOption2(obj) {
	
}

//オプションを部屋ごとに表示　＆　ボタン表示
function visibleOption(obj) {
	console.log("visibleOption position:" + obj.position);
	switch(obj.position) {
		case 0:
			//1の部屋　中央
			//背景 : 0
			obj.back_mc.gotoAndStop(0);
			//オプション : ドア
			if(obj.gameEvents[E_USE_KEY1] == 1) {
				obj.o2.visible = true;
			} else {
				obj.o1.visible = true;
			}
			obj.btn_o1.visible = true;
			break;
		case 1:
			//1の部屋　右
			//背景 : 1
			obj.back_mc.gotoAndStop(1);
			//オプション　つぼx3
			if(obj.gameEvents[E_BREAK_POD1] != 1) obj.o3.visible = true;
			if(obj.gameEvents[E_BREAK_POD2] != 1) obj.o4.visible = true;
			if(obj.gameEvents[E_BREAK_POD3] != 1) obj.o5.visible = true;
			if(obj.gameEvents[E_BREAK_POD1] != 1) obj.btn_o3.visible = true;
			if(obj.gameEvents[E_BREAK_POD2] != 1) obj.btn_o4.visible = true;
			if(obj.gameEvents[E_BREAK_POD3] != 1) obj.btn_o5.visible = true;
			if(obj.gameEvents[E_BREAK_POD1] == 1 && obj.gameEvents[E_PICK_MEDAL1] != 1) {
				obj.o50.visible = true;
				obj.btn_o6.visible = true;
			}
			break;
		case 2:
			obj.back_mc.gotoAndStop(2);
			if(obj.gameEvents[E_PICK_KEY0] != 1) {
				obj.o6.visible = true;
				obj.btn_o6.visible = true;
			}

			if(obj.gameEvents[E_SLEEP_FAIRY1] != 1) {
				obj.o32.visible = true;
				obj.btn_o32.visible = true;
			} else {
				obj.o41.visible = true;
				obj.btn_o41.visible = true;
			}
			
			break;

		case 3:
			//2の部屋　中央
			//背景
			obj.back_mc.gotoAndStop(0);
			//かげ
			if(obj.lump_statuses[4] == 1 && obj.lump_statuses[5] == 1) {
				obj.o11.visible = true;
			} else if(obj.lump_statuses[4] == 1) {
				obj.o9.visible = true;
			} else if(obj.lump_statuses[5] == 1) {
				obj.o10.visible = true;
			} else {
				obj.o7.visible = true;
			}
			//クリスタル
			obj.btn_o12.visible = true;
			obj.btn_o13.visible = true;
			if(obj.lump_statuses[4] == 1) {
				obj.o14.visible = true;
			} else {
				obj.o12.visible = true;
			}
			if(obj.lump_statuses[5] == 1) {
				obj.o15.visible = true;
			} else {
				obj.o13.visible = true;
			}

			//たから
			if(obj.gameEvents[E_PICK_SAO] == 1) {
				obj.o22.visible = true;
				obj.btn_o17.visible = true;
			} else {
				obj.o17.visible = true;
				obj.btn_o17.visible = true;
			}
			
			//ロープ
			obj.o16.visible = true;
			obj.btn_o16.visible = true;

			if(obj.lump_statuses[4] == 1 && obj.gameEvents[E_PICK_KEY2] != 1) {
				//かぎ
				obj.o23.visible = true;//
				obj.btn_o23.visible = true;//
			}

			break;

		

		case 19:
			obj.tutorial_mc.visible = true;
			obj.tutorial_mc.gotoAndStop(5);
			obj.tutorial_mc.comment_mc.gotoAndStop(5);
			break;

		default:
	}
}

//稼働部屋　上右下左
function getMovableRoom(obj) {
	var result = [NaN, NaN, NaN, NaN];
	switch(obj.position) {
		//------ room1
		case 0:
			if(obj.gameEvents[E_USE_KEY1] == 1) {
				if(TRIAL_FLG) {
					result = [19, 1, NaN, 2];
				} else {
					result = [3, 1, NaN, 2];
				}
			} else {
				result = [NaN, 1, NaN, 2];
			}
			break;
		case 1:
			result = [NaN, NaN, NaN, 0];
			break;
		case 2:
			result = [NaN, 0, NaN, NaN];
			break;

		//------ room2
		case 3:
			result = [NaN, 4, 0, 5];
			break;
		
		//----- room - trial
		case 19:
			result = [NaN, NaN, 0, NaN];
			break;

		default:
	}
	return result;
}

//クリスタルランプを飾る
function setLumps(obj, num) {
	if(obj.lump_statuses[num] == 0 && obj.selectItem != 5 && obj.selectItem != 6) {
		var messages = ["燭台だ。ここに明かりを灯せばこの部屋も明るくなるかな・・・？"];
		displayMessage(obj, messages, 0, messages.length-1);
		return;
	}

	if(obj.lump_statuses[num] == 0 && (obj.items[5] == 1 || obj.items[6] == 1) ) {

		obj.lump_statuses[num] = 1;
		if(obj.items[5] == 1) {
			obj.items[5] = 0;
		} else if(obj.items[6] == 1) {
			obj.items[6] = 0;
		}
		obj.selectItem = NaN;

		if(obj.gameEvents[E_SET_LUMPS] != 1) {
			if(obj.lump_statuses[1] == 1 && obj.lump_statuses[5] == 1) {
				updateGameEvent(obj, E_SET_LUMPS);
				playsound(obj, 4);
				obj.eventMessage = true;
				var messages = ["クリスタルランプを燭台に飾った！", "宝箱が出現した！"];
				displayMessage(obj, messages, 0, messages.length-1);
			} else {
				var messages = ["クリスタルランプを燭台に飾った！"];
				displayMessage(obj, messages, 0, messages.length-1);
				playsound(obj, 6);
			}
		} else {
			var messages = ["クリスタルランプを燭台に飾った！"];
			displayMessage(obj, messages, 0, messages.length-1);
			playsound(obj, 6);
		}
		
		resetDisplay(obj);

	} else if(obj.lump_statuses[num] == 1) {
		var messages = ["クリスタルランプを燭台から外しますか？"];
		displayMessage(obj, messages, 0, messages.length-1);
		obj.selectId = 1;
		obj.selectOption = num;//ランプの位置
		displaySelect(obj, ["は　い", "いいえ"]);
	} else {
		
	}
}

//サブイベント
function displaySubGameEvent(obj) {
	if(obj.gameEventId == 1) {
		obj.eventFlg = 0;
		//room3 ドアをあけてもらう
		playsound(obj, 5);
		resetDisplay(obj);
		return;
	}
	if(obj.gameEventId == 2) {
		//room3 宝箱の熱が引く
		obj.eventFlg = 0;
		resetDisplay(obj);
		playsound(obj, 4);
		return;
	}
	if(obj.gameEventId == 3) {
		//選択肢
		obj.selectId = 3;
		obj.selectOption = 0;
		displaySelect(obj, ["は　い", "いいえ"]);
		obj.eventFlg = 0;
		return;
	}

	if(obj.gameEventId == 4) {
		//room4 ツボ破壊
		obj.eventFlg = 0;
		resetDisplay(obj);
		playsound(obj, 6);
		return;
	}

	if(obj.gameEventId == 5) {
		//選択肢
		obj.selectId = 4;
		obj.selectOption = 0;
		displaySelect(obj, ["グー", "チョキ", "パー"]);
		obj.eventFlg = 0;
		obj.optionEvent = 2;
		obj.fairyHandId = setTimeout(onOption2, 3000, obj);
		return;
	}

	if(obj.gameEventId == 6) {
		obj.eventFlg = 0;
		obj.fairy_mc.visible = false;
	}

	if(obj.gameEventId == 7) {
		obj.eventFlg = 0;
		playsound(obj, 8);
		resetDisplay(obj);
	}

	if(obj.gameEventId == 8) {
		//選択肢
		obj.selectId = 5;
		obj.selectOption = 0;
		displaySelect(obj, ["なぐる", "服を調べる", "場所を移動させる", "あっかんべー"]);
		obj.eventFlg = 0;
		return;
	}

	if(obj.gameEventId == 9) {
		//room4 ツボ倒す
		obj.eventFlg = 0;
		resetDisplay(obj);
		playsound(obj, 10);
		return;
	}

	if(obj.gameEventId == 10) {
		//リッツ画像を消す
		exeobj.gameEvents[E_GAME_FIRST] = 1;
		obj.eventFlg = 0;
	}

}

function displaySelect(obj, sels) {
	obj.btn_sel1.visible = true;
	obj.btn_sel2.visible = true;
	if(sels.length>=3) obj.btn_sel3.visible = true;
	if(sels.length>=4) obj.btn_sel4.visible = true;
	obj.selection_mc1.visible = true;
	obj.selection_mc2.visible = true;
	if(sels.length>=3) obj.selection_mc3.visible = true;
	if(sels.length>=4) obj.selection_mc4.visible = true;

	obj.selection_mc1.sel_txt.text = sels[0];
	obj.selection_mc2.sel_txt.text = sels[1];
	if(sels.length>=3) obj.selection_mc3.sel_txt.text = sels[2];
	if(sels.length>=4) obj.selection_mc4.sel_txt.text = sels[3];
}

function unDisplaySelect(obj) {
	obj.btn_sel1.visible = false;
	obj.btn_sel2.visible = false;
	obj.btn_sel3.visible = false;
	obj.btn_sel4.visible = false;

	obj.selection_mc1.sel_txt.text = "";
	obj.selection_mc2.sel_txt.text = "";
	obj.selection_mc3.sel_txt.text = "";
	obj.selection_mc4.sel_txt.text = "";

	obj.selection_mc1.visible = false;
	obj.selection_mc2.visible = false;
	obj.selection_mc3.visible = false;
	obj.selection_mc4.visible = false;
}

//選択肢押下 num:ユーザ選択　selectId:問題番号
function onSelect(obj, num) {
	switch (obj.selectId) {
		case 1:
			if(num == 1) {
				//ランプを外す
				obj.lump_statuses[obj.selectOption] = 0;
				if(obj.items[5] == 0) {
					obj.items[5] = 1;
				} else if(obj.items[6] == 0) {
					obj.items[6] = 1;
				}
				obj.selectItem = NaN;
				resetDisplay(obj);
			}
			break;
		case 2:
			if(num == 1) {
				//ロープトラップにかかる
				obj.eventMessage = true;
				var messages = ["ロープを引っ張った", "ロープの正体はエロモンスターの擬態だった！"];
				displayMessage(obj, messages, 0, messages.length-1);
				obj.eventFlg = 1;
				obj.gameEventId = 3;
				unDisplaySelect(obj);
				obj.selectId = NaN;
				return;
			}
			break;
		case 3:
			if(num == 1) {
				obj.eventMessage = true;
				var messages = ["＊「ありがてえっ」", "ブロックは肉をたいらげた", "＊「お礼にここのドアを開けてやるよ」"];
				displayMessage(obj, messages, 0, messages.length-1);
				obj.gameEvents[E_GIVE_MEAT] = 1;
				obj.gameEvents[E_OPEN_DOOR3] = 1;
				updateGameEvent(obj, E_GIVE_MEAT);
				updateGameEvent(obj, E_OPEN_DOOR3);
				obj.selectId = NaN;
				obj.eventFlg = 2;
				obj.gameEventId = 1;
				obj.selectItem = NaN;
				unDisplaySelect(obj);
				obj.items[2] = 0;
				setGameItems(obj, obj.itemPosition);
				return;
			} else if(num == 2) {
				var messages = ["＊「ケチ」"];
				displayMessage(obj, messages, 0, messages.length-1);
				obj.selectId = NaN;
				obj.selectItem = NaN;
				unDisplaySelect(obj);
				setGameItems(obj, obj.itemPosition);
				return;
			}
			break;

		case 4:
			//じゃんけん
			obj.selectId = NaN;
			obj.selectItem = NaN;
			unDisplaySelect(obj);
			var winCode = 0;
			if(isNaN(obj.fairyHand)) {
				obj.fairyHand = 1;
				if(num == 1) {
					obj.fairy_mc.hand_mc.gotoAndStop(3);
				} else if(num == 2) {
					obj.fairy_mc.hand_mc.gotoAndStop(1);
				} else if(num == 3) {
					obj.fairy_mc.hand_mc.gotoAndStop(2);
				}
			} else {
				if(num == obj.fairyHand == 1) {
					winCode = 1;
				}
				if(num == 1 && obj.fairyHand == 2) {
					winCode = 2;	
				}
				if(num == 2 && obj.fairyHand == 3) {
					winCode = 2;	
				}
				if(num == 3 && obj.fairyHand == 1) {
					winCode = 2;	
				}
			}

			obj.eventMessage = true;
			if(winCode == 0) {
				var r = getRandomInt(3);
				var messages = [];
				if(r==0) {
					messages = ["＊「私の勝ち！」", "＊「たかがじゃんけん、そう思ってない？　そうだったら次も私の勝ちよ。」"];
				} else if(r==1) {
					messages = ["＊「私の勝ち！」", "＊「なんで負けたのか、次の勝負までに考えてきてね。そしたら何かが見えてくるはずよ。」"];
				} else {
					messages = ["＊「私の勝ち！」", "＊「たかがじゃんけん、そう思ってない？　そうだったら次も私の勝ちよ。じゃあ、いただきます。」", "リッツ「なにを？」"];
				}
				obj.playcount ++;
				displayMessage(obj, messages, 0, messages.length-1);
				obj.eventFlg = 2;
				obj.gameEventId = 6;
				clearTimeout(obj.fairyHandId);
				return;
			} else if(winCode == 1) {
				var messages = ["＊「！？」", "＊「あいこだから、もう一度勝負しましょう。」"];
				displayMessage(obj, messages, 0, messages.length-1);
				obj.eventFlg = 2;
				obj.gameEventId = 6;
				return;
			} else {
				var messages = ["＊「あっ！？負けたわ...。」", "＊「約束通り、イイモノをあげるわ。」", "木の桐箱を手に入れた！"];
				displayMessage(obj, messages, 0, messages.length-1);
				updateGameEvent(obj, E_WIN_FAIRY);
				obj.getItemId = 12;
				obj.getItemMessagePage = 2;
				obj.getItemSound = 1;
				return;
			}
			
		case 5:
			//ブロックへの対応
			//obj.selectId = NaN;
			//obj.selectItem = NaN;
			formatSelectItem(obj);
			unDisplaySelect(obj);
			//setGameItems(obj);

			if(num == 1) {
				obj.eventMessage = true;
				var messages = ["ブロックを思い切りなぐった！\r1のダメージをあたえた！", "ブロックは目を覚ました。", "＊「てめえ、なにしやがるっ！」"];
				displayMessage(obj, messages, 0, messages.length-1);
				obj.eventFlg = 1;
				obj.gameEventId = 4;
				obj.gameEvents[E_SLEEP_GOBLIN] = 0;
				resetOption(obj);
				return;
			}
			if(num == 2) {
				if(obj.gameEvents[E_PICK_MEDAL3] == 1) {
					obj.eventMessage = true;
					var messages = ["ブロックの服を調べた！", "ブロックは目を覚ました。", "＊「おい、何をしているっ！」"];
					displayMessage(obj, messages, 0, messages.length-1);
					obj.eventFlg = 1;
					obj.gameEventId = 4;
					obj.gameEvents[E_SLEEP_GOBLIN] = 0;
					resetOption(obj);
					return;
				} else {
					obj.eventMessage = true;
					var messages = ["ブロックの服を調べた！", "緑のメダルを手に入れた！"];
					displayMessage(obj, messages, 0, messages.length-1);
					updateGameEvent(obj, E_PICK_MEDAL3);
					obj.getItemId = 17;
					obj.getItemMessagePage = 1;
					obj.getItemSound = 1;
					return;	
				}
			}

			if(num == 3) {
				obj.eventMessage = true;
				var messages = ["ブロックを転がして移動させようとした", "しかし重くて動かなかった"];
				displayMessage(obj, messages, 0, messages.length-1);
				return;
			}

			if(num == 4) {
				obj.eventMessage = true;
				var messages = ["リッツ「あっかんべー！」", "・・・", "しかし何もおこらなかった"];
				displayMessage(obj, messages, 0, messages.length-1);
				return;
			}

		default : 
			break;
	}
	
	//選択肢終了
	obj.selectId = NaN;
	formatMessage(obj);
	unDisplaySelect(obj);

}

function isOpenDoor5(obj) {
	if(obj.gameEvents[E_SET_MEDAL1] == 1 && obj.gameEvents[E_SET_MEDAL2] == 1 && obj.gameEvents[E_SET_MEDAL3] == 1 && obj.gameEvents[E_OPEN_DOOR5] != 1) {
		updateGameEvent(obj, E_OPEN_DOOR5);
		obj.o46.visible = true;
		obj.o47.visible = true;
		playsound(obj, 7);
		obj.o51.visible = false;
		obj.o52.visible = false;
		obj.o53.visible = false;
		obj.o45.gotoAndPlay(1);
	}
}

//
function setMoveEffect(obj, oldPosition, newPosition) {
	obj.map_mc.gotoAndStop(newPosition);
	if(isBlackOut(oldPosition, newPosition)) {
		obj.blackout_mc.gotoAndPlay(1);
	}
}

function isBlackOut(oldPosition, newPosition) {
	if(oldPosition == 0  && newPosition == 3)  return true;
	if(oldPosition == 3  && newPosition == 0)  return true;
	if(oldPosition == 4  && newPosition == 7)  return true;
	if(oldPosition == 7  && newPosition == 4)  return true;
	if(oldPosition == 9  && newPosition == 11) return true;
	if(oldPosition == 11 && newPosition == 9)  return true;
	if(oldPosition == 13 && newPosition == 15) return true;
	if(oldPosition == 15 && newPosition == 13)  return true;
	return false;
}

//通信　クリア
function connectClear(obj) {
    $.ajax(URL_CLEAR, {
        type: 'post',
        data: { "aid": CEG_AID , "sk": obj.cegSessionKey, "pt": 100,  "cs": getCheckstr(obj) },
        dataType: 'json',
        timeout: 3000,
      }
    )
    // 通信成功
    .done(function(res) {
        //console.log('通信成功');
        //console.log(res["send"]);
        //console.log(res["clearDate"]);
        //console.log(res["clearRank"]);
        //console.log("XMLHttpRequest : " + JSON.stringify(res));
        responseClear(res["send"], res["clearDate"], res["clearRank"], obj);
    })
    // 通信失敗(タイムアウトまたはサーバエラー)
    .fail(function(XMLHttpRequest, textStatus, errorThrown) {
        //console.log("通信失敗");
        //console.log("XMLHttpRequest : " + JSON.stringify(XMLHttpRequest));
        //console.log("textStatus     : " + textStatus);
        //console.log("errorThrown    : " + errorThrown.message);
        errorClear(obj);
    });
}

//通信後
function responseClear(send, clearDate, clearRank, obj) {

	if(send == CODE_RANKIN) {
		obj.clear_date_txt2.visible = true;
		obj.clear_mc.visible = true;
		obj.ranking_mc.visible = true;
		obj.clear_back_mc.visible = true;
		obj.btn_tweet.visible = true;
		obj.tweet_mc.visible = true;

		localStorage.setItem("erotrap_recordscore", clearDate);
		localStorage.setItem("erotrap_clear_rank", clearRank);
		setNumberMc9(obj.ranking_mc, clearRank);
		obj.clear_date_txt2.text = clearDate;
		obj.clearRank = clearRank;
		

	} else if(send == CODE_READY_CLEAR) {
		obj.ready_clear_str_mc.visible = true;
		obj.ready_clear_back_mc.visible = true;
		obj.btn_tweet.visible = true;
		obj.tweet_mc.visible = true;
	} else {
		//alert(getCheckstr(obj));
	}
	
}

//再通信
function errorClear(obj) {
	var result = window.confirm('通信に失敗しました。もう一度通信しますか？');
    
    if( result ) {
        connectClear(obj);
    }
    else {
        
    }
}

//ツイートボタン
function onTweet(obj) {
	var tweetStr = "";
	tweetStr += "https://twitter.com/intent/tweet?related=odm&source=tweetbutton&text=";
	tweetStr += "%23リッツのエロトラップダンジョンからの脱出";
	tweetStr += "%20" + "脱出成功！！";
	if(obj.clearRank != undefined && obj.clearRank != "undefined") tweetStr += "%20" + "クリア順ランキング" + obj.clearRank + "位";
	tweetStr += "%20https://printdora-s3-files.s3-ap-northeast-1.amazonaws.com/5/erotrap_escape.html";
	open( tweetStr, "_blank" ) ;
}

function updateGameEvent(obj, num) {
	obj.gameEvents[num] = 1;
	sendCegData(CEG_AID, obj.cegSessionKey, num);
}

function displayTutorial(obj) {
	if(obj.position == 19) {
		obj.tutorial_mc.visible = true;
		obj.tutorial_mc.comment_mc.gotoAndStop(5);
		return;
	} else {
		obj.tutorial_mc.visible = false;
	}
	return;
}