//-----------------------------------
//トップページ　リスナー登録
//-----------------------------------
function addTopListener(obj) {
	obj.btn_start_mc.addEventListener('click', obj, false);
	obj.btn_start_mc.addEventListener('touchstart', obj, false);
	obj.btn_setting_mc.addEventListener('click', obj, false);
	obj.btn_setting_mc.addEventListener('touchstart', obj, false);
	obj.btn_gallery_mc.addEventListener('click', obj, false);
	obj.btn_gallery_mc.addEventListener('touchstart', obj, false);
	obj.btn_ranking_mc.addEventListener('click', obj, false);
	obj.btn_ranking_mc.addEventListener('touchstart', obj, false);
	obj.btn_dummy_mc.addEventListener('click', obj, false);
	obj.btn_dummy_mc.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "btn_start_mc") {
	      		onStart(obj);
	        } else if(event.target.parent.name == "btn_setting_mc") {
	        	obj.setting_mc.gotoAndStop(1);
	        	if(obj.soundFlg != FLG_ON) {
			    	obj.setting_mc.sound_mc.gotoAndStop(1);
			    } else {
			    	obj.setting_mc.sound_mc.gotoAndStop(0);
			    }
	        	if(TRIAL_FLG) {
	        		obj.setting_mc.btn_inputpass_mc.visible = false;
	        		obj.setting_mc.btn_change_name_mc.visible = false;
	        		obj.setting_mc.password_display_mc.visible = false;
	        	} else {
	        		obj.setting_mc.passText.text = obj.cegPassword;
	        	}
	        	addSettingListener(obj);
	        	removeTopListener(obj);
	        	setTimeout(displayFormovieCheck, 100, obj);
	        	/*
	        	obj.window_setting_mc.gotoAndStop(1);
	        	setSoundMc(obj);
	        	obj.window_setting_mc.top_select_mc.visible = false;

	        	if(TRIAL_FLG) {
	        		obj.window_setting_mc.btn_inputpass_mc.visible = false;
	        		obj.window_setting_mc.btn_change_name_mc.visible = false;
	        		obj.window_setting_mc.password_display_mc.visible = false;
	        	} else {
	        		obj.window_setting_mc.passText.text = obj.cegPassword;
	        	}
	        	
	        	//設定画面
	        	removeTopListener(obj);
	        	setTimeout(addSettingListener, 100, obj);
	        	*/
	        	
	        } else if(event.target.parent.name == "btn_gallery_mc") {
	        	obj.gallery_mc.gotoAndStop(1);
	        	displayGalleryIcon(obj);
	        	addGalleryListener(obj);
	        	removeTopListener(obj);
	        } else if(event.target.parent.name == "btn_ranking_mc") {
	        	var term = judgeTerm();
			    if(term != 3) {
			        //SP
			        location.href = "ranking.html";
			    } else {
			    	//PC
			    	location.href = "rankingpc.html";
			    }
	        } else if(event.target.parent.name == "btn_dummy_mc") {
	        	
	        } else {
	        }
	        break;
	    }
	};
}

//トップページ　リスナー削除
function removeTopListener(obj) {
	obj.btn_start_mc.removeEventListener('click', obj, false);
	obj.btn_start_mc.removeEventListener('touchstart', obj, false);
	obj.btn_setting_mc.removeEventListener('click', obj, false);
	obj.btn_setting_mc.removeEventListener('touchstart', obj, false);
	obj.btn_gallery_mc.removeEventListener('click', obj, false);
	obj.btn_gallery_mc.removeEventListener('touchstart', obj, false);
	obj.btn_ranking_mc.removeEventListener('click', obj, false);
	obj.btn_ranking_mc.removeEventListener('touchstart', obj, false);
}

//スタートボタン押下
function onStart(obj) {
	//2フレームへ
	obj.gotoAndStop(2);

	//ゲーム画面初期化
	formatGameDisplay();

	//リスナー
	addGameListener(obj);
	removeTopListener(obj);
}

//-----------------------------------
//設定画面リスナー
//-----------------------------------
function addSettingListener(obj) {
	obj.setting_mc.btn_close_mc.addEventListener('click', obj, false);
	obj.setting_mc.btn_close_mc.addEventListener('touchstart', obj, false);
	obj.setting_mc.btn_password_mc.addEventListener('click', obj, false);
	obj.setting_mc.btn_password_mc.addEventListener('touchstart', obj, false);
	obj.setting_mc.btn_changename_mc.addEventListener('click', obj, false);
	obj.setting_mc.btn_changename_mc.addEventListener('touchstart', obj, false);
	obj.setting_mc.btn_sound_mc.addEventListener('click', obj, false);
	obj.setting_mc.btn_sound_mc.addEventListener('touchstart', obj, false);
	obj.setting_mc.btn_datadelete_mc.addEventListener('click', obj, false);
	obj.setting_mc.btn_datadelete_mc.addEventListener('touchstart', obj, false);
	obj.setting_mc.btn_inputpass_mc.addEventListener('click', obj, false);
	obj.setting_mc.btn_inputpass_mc.addEventListener('touchstart', obj, false);
	obj.setting_mc.btn_formovie_mc.addEventListener('click', obj, false);
	obj.setting_mc.btn_formovie_mc.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "btn_close_mc") {
	      		onSettingClose(obj);
	        }if(event.target.parent.name == "btn_inputpass_mc") {
	        	alert("現在のパスワードです。["+obj.cegPassword+"]スクリーンショットを撮っておきましょう。");
	        } else if(event.target.parent.name == "btn_password_mc") {
	        	console.log("btn_password_mc");
	        	var inputPass = prompt("パスワードを入力することでその時のデータから開始できます。(現在のデータは消去されます)", "");
	        	if(inputPass != undefined && inputPass != null && inputPass != "") {
	        		changeCegAccount(inputPass, obj);
	        	}
	        } else if(event.target.parent.name == "btn_changename_mc") {
	        	console.log("btn_changename_mc");
	        	if(TRIAL_FLG) return;
	        	var inputName = prompt("名前を入力してください", obj.cegUserName);
	        	if(inputName != undefined && inputName != null && inputName != "") {
	        		changeCegUserName(CEG_AID, obj.cegSessionKey, inputName, obj);
	        	}
	        } else if(event.target.parent.name == "btn_sound_mc") {
	        	console.log("btn_sound_mc");
	        	if(obj.soundFlg != FLG_ON) {
			    	obj.soundFlg = FLG_ON;
			    	obj.setting_mc.sound_mc.gotoAndStop(0);
			    } else {
			    	obj.soundFlg = FLG_OFF;
			    	obj.setting_mc.sound_mc.gotoAndStop(1);
			    }
			    setCegSoundFlg(CEG_AID, obj.soundFlg);
	        } else if(event.target.parent.name == "btn_datadelete_mc") {
	        	console.log("btn_datadelete_mc");
	        	onDeleteData(obj);
	        } else if(event.target.parent.name == "btn_formovie_mc") {
	        	console.log("btn_formovie_mc");
	        	changeFormovie(obj);
	        } else {
	        }
	        break;
	    }
	};
}
function removeSettingListener(obj) {
	obj.setting_mc.btn_close_mc.removeEventListener('click', obj, false);
	obj.setting_mc.btn_close_mc.removeEventListener('touchstart', obj, false);
}

//設定画面閉じる
function onSettingClose(obj) {
	removeSettingListener(obj);
	//1フレームへ
	obj.setting_mc.gotoAndStop(0);
	addTopListener(obj);
}

//-----------------------------------
//ギャラリー画面リスナー
//-----------------------------------
function addGalleryListener(obj) {
	obj.gallery_mc.btn_close_mc.addEventListener('click', obj, false);
	obj.gallery_mc.btn_close_mc.addEventListener('touchstart', obj, false);
	obj.gallery_mc.g0.addEventListener('click', obj, false);
	obj.gallery_mc.g0.addEventListener('touchstart', obj, false);
	obj.gallery_mc.g1.addEventListener('click', obj, false);
	obj.gallery_mc.g1.addEventListener('touchstart', obj, false);
	obj.gallery_mc.g2.addEventListener('click', obj, false);
	obj.gallery_mc.g2.addEventListener('touchstart', obj, false);
	obj.gallery_mc.g3.addEventListener('click', obj, false);
	obj.gallery_mc.g3.addEventListener('touchstart', obj, false);
	obj.gallery_mc.g4.addEventListener('click', obj, false);
	obj.gallery_mc.g4.addEventListener('touchstart', obj, false);
	obj.gallery_mc.g5.addEventListener('click', obj, false);
	obj.gallery_mc.g5.addEventListener('touchstart', obj, false);
	obj.gallery_mc.g6.addEventListener('click', obj, false);
	obj.gallery_mc.g6.addEventListener('touchstart', obj, false);
	obj.gallery_mc.g7.addEventListener('click', obj, false);
	obj.gallery_mc.g7.addEventListener('touchstart', obj, false);

	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "btn_close_mc") {
	      		onGalleryClose(obj);
	        } else if(GALLERY_REGEXP.test(event.target.parent.name)) {
	        	//選択肢
	        	onGallery(obj, event.target.parent.name.substr(1));
	        } else {
	        }
	        break;
	    }
	};
}
function removeGalleryListener(obj) {
	obj.gallery_mc.btn_close_mc.removeEventListener('click', obj, false);
	obj.gallery_mc.btn_close_mc.removeEventListener('touchstart', obj, false);
	obj.gallery_mc.g0.removeEventListener('click', obj, false);
	obj.gallery_mc.g0.removeEventListener('touchstart', obj, false);
	obj.gallery_mc.g1.removeEventListener('click', obj, false);
	obj.gallery_mc.g1.removeEventListener('touchstart', obj, false);
	obj.gallery_mc.g2.removeEventListener('click', obj, false);
	obj.gallery_mc.g2.removeEventListener('touchstart', obj, false);
	obj.gallery_mc.g3.removeEventListener('click', obj, false);
	obj.gallery_mc.g3.removeEventListener('touchstart', obj, false);
	obj.gallery_mc.g4.removeEventListener('click', obj, false);
	obj.gallery_mc.g4.removeEventListener('touchstart', obj, false);
	obj.gallery_mc.g5.removeEventListener('click', obj, false);
	obj.gallery_mc.g5.removeEventListener('touchstart', obj, false);
	obj.gallery_mc.g6.removeEventListener('click', obj, false);
	obj.gallery_mc.g6.removeEventListener('touchstart', obj, false);
	obj.gallery_mc.g7.removeEventListener('click', obj, false);
	obj.gallery_mc.g7.removeEventListener('touchstart', obj, false);
}

//設定画面閉じる
function onGalleryClose(obj) {
	removeGalleryListener(obj);
	//1フレームへ
	obj.gallery_mc.gotoAndStop(0);
	addTopListener(obj);
}

//-----------------------------------
//メッセージリスナー
//-----------------------------------
function addMessageListener(obj) {
	obj.message_box_mc.addEventListener('click', obj, false);
	obj.message_box_mc.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "message_box_mc") {
	      		onMessageBox(obj);
	        } else if(event.target.parent.name == "btn_setting_mc") {
	        } else {
	        }
	        break;
	    }
	};
}
function removeMessageListener(obj) {
	obj.message_box_mc.removeEventListener('click', obj, false);
	obj.message_box_mc.removeEventListener('touchstart', obj, false);
}
function onMessageBox(obj) {
	if(obj.messageDoneFlg) {

	} else {
		removeMessageListener(obj);
		formatMessage(obj);
	}
}

//-----------------------------------
//ゲーム中のframe
//-----------------------------------
function onFrameMessage(obj) {
	//テキストを回す
	progressWord(obj);
}

//-----------------------------------
//ゲーム外
//-----------------------------------
function closeAd() {
	
}

function closeLink() {
	
}

function closeGameEvent() {
	document.getElementById("interGameEvent").style.display = "none";
}

//-----------------------------------
//通信戻り
//-----------------------------------

//アカウント変更後
function responseChangeCegAccount(name, pass, session_key, obj) {
	//データ取得
	obj.cegUserName = name;
	obj.cegPassword = pass;
	obj.name_txt.text = "@" + obj.cegUserName;
	loadValue(CEG_AID, session_key, obj);
	obj.setting_mc.passText.text = pass;
}

//アカウント変更エラー
function errorChangeCegAccount(obj) {
	window.alert("エラーです。通信状況とパスワードをご確認ください。");
}

function passerrorChangeCegAccount(obj) {
	window.alert("パスワードエラーです。Iとlなど似た文字にご注意ください。");
}

function responseSaveValue(obj) {
	console.log("erotrap_escape responseSaveValue");
	//window.alert("保存しました。");
}

//アカウント変更後のデータ取得通信の戻り
function responseLoadValue(res, obj) {
	obj.gameData = JSON.parse(res);
	obj.recordScore   = resZeroUndefined(Number(obj.gameData["recordScore"]));
	obj.gameEvents = obj.gameData["gameEvents"];
	obj.items = obj.gameData["items"];
	obj.position = obj.gameData["position"];
	obj.galleries = obj.gameData["galleries"];
	obj.lump_statuses = obj.gameData["gameEvents"][E_LUMP_STATUS];
	localStorage.setItem("erotrap_recordscore", obj.recordScore);

	saveData(obj);

	obj.recordScore = displayRecord(obj.clear_score_mc, obj.clear_date_txt);
	
	window.alert("データを切り替えました");
}

function errorSaveValue(obj) {

}

function errorLoadValue(obj) {
	
}